﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ClientCommands
{
	public partial class Form1 : Form
	{
		int m_nSelPos = 0;
		int m_nSubPos = 0;
		ListViewItem.ListViewSubItem m_SelectedLSI;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			// Init controls
			CmdList.Items.Add("---------------------------");
			// Functions
			CmdList.Items.Add("NStartClient");
			CmdList.Items.Add("NStopClient");
			CmdList.Items.Add("NNetworkConfigDialog");
			CmdList.Items.Add("TMakeCall");
			CmdList.Items.Add("TCallDrop");
			CmdList.Items.Add("TRemovePhoneIcon");
			CmdList.Items.Add("TReDial");
			CmdList.Items.Add("NLogin");
			CmdList.Items.Add("NLogoff");
			CmdList.Items.Add("NPrepareRestart");
			CmdList.Items.Add("TCallAnswer");
			CmdList.Items.Add("TCallHold");
			CmdList.Items.Add("TCallUnHold");
			CmdList.Items.Add("ESendUserToUser");
			CmdList.Items.Add("EUserSendToDataBase");
			CmdList.Items.Add("TPickup");
			CmdList.Items.Add("EShowInfoDialog");
			CmdList.Items.Add("TCallTransfer");
			CmdList.Items.Add("ESetMainWindow");
			CmdList.Items.Add("EChatStart");
			CmdList.Items.Add("EChatEnd");
			CmdList.Items.Add("EChatMessage");
			CmdList.Items.Add("TAddCallToConference");
			CmdList.Items.Add("TAddNumberToConference");
			CmdList.Items.Add("EExpandInternNumber");
			CmdList.Items.Add("TLineReset");
			CmdList.Items.Add("TProxyMakeCall");
			CmdList.Items.Add("ESetAcdReady");
			CmdList.Items.Add("SQLLogin");
			CmdList.Items.Add("SQLBegin");
			CmdList.Items.Add("SQLNext");
			CmdList.Items.Add("SQLEnd");
			CmdList.Items.Add("SQLGetDbBook");
			CmdList.Items.Add("EConvertToCanonical");
			CmdList.Items.Add("OConnectionIconOptions");
			CmdList.Items.Add("TCallAlternate");
			CmdList.Items.Add("TCallRedirect");
			CmdList.Items.Add("TSendCallReminder");
			CmdList.Items.Add("TSetForwarding");
			CmdList.Items.Add("EGetFormatDateTime");
			CmdList.Items.Add("EGetDateTime");
			
			// Properties
			CmdList.Items.Add("OShowIcon");
			CmdList.Items.Add("OAutoConnect");
			CmdList.Items.Add("OAssistedTelephony");
			CmdList.Items.Add("OShowMenu");
			CmdList.Items.Add("OAutoLogin");
			CmdList.Items.Add("OHotKey");
			CmdList.Items.Add("OPhoneIcon");
			CmdList.Items.Add("OCheckConnection");
			CmdList.Items.Add("OAutoAnswer");
			CmdList.Items.Add("OQuickMouseDial");
			CmdList.Items.Add("EPrivateState");
			CmdList.Items.Add("NClientActive");
			CmdList.Items.Add("NServerName");
			CmdList.Items.Add("NPortNumber");
			CmdList.Items.Add("OIniFileName");
			CmdList.Items.Add("OOwnerNumber");
			CmdList.Items.Add("OOptions");
			CmdList.Items.Add("OUserCallInfo");
			CmdList.Items.Add("NClientCount");
			CmdList.Items.Add("ODropSpecialKey");
			CmdList.Items.Add("ODropKey");
			CmdList.Items.Add("ODialSpecialKey");
			CmdList.Items.Add("ODialKey");
			CmdList.Items.Add("TForwardingState");
			CmdList.Items.Add("TForwardingDest");
			CmdList.Items.Add("OOwnerName");
			CmdList.Items.Add("TRedialNumber");
			CmdList.Items.Add("NumberOfInstances");
			int nInit = CmdList.Items.IndexOf("NStartClient");
			CmdList.SetSelected(nInit, true);

			// Init Param List
			ParamList.Columns.Add("Param", 120);
			ParamList.Columns.Add("Type", 120);
			ParamList.Columns.Add("Value", 200);

			// Init Event List
			EventList.Columns.Add("Event name", 100);
			EventList.Columns.Add("Param", 100);
			EventList.Columns.Add("Type", 100);
			EventList.Columns.Add("Value", 200);
		}

		private void Form1_Activated(object sender, EventArgs e)
		{
			ResizeComponents();
		}

		private void Form1_SizeChanged(object sender, EventArgs e)
		{
			// Resize controls
			ResizeComponents();
		}

		private void InsertParamListItem(int nPos, bool bEditable, string sName, string sType, string sValue)
		{
			ParamList.Items.Add(sName);
			if (bEditable) { ParamList.Items[nPos].UseItemStyleForSubItems = false; }
			ParamList.Items[nPos].SubItems.Add(sType);
			ParamList.Items[nPos].SubItems.Add(sValue);
			if (bEditable)
			{
				ParamList.Items[nPos].SubItems[2].BackColor = System.Drawing.Color.Beige;
			}// if (bEditable) 
		}

		private void InsertEventListItem(string EventName, string Param, string Type, string Value)
		{
			EventList.Items.Add(EventName);
			int nPos = EventList.Items.Count - 1;
			if (EventName != "") { EventList.Items[nPos].BackColor = System.Drawing.Color.Aquamarine; }
			EventList.Items[nPos].SubItems.Add(Param);
			EventList.Items[nPos].SubItems.Add(Type);
			EventList.Items[nPos].SubItems.Add(Value);
			EventList.Items[nPos].EnsureVisible();
		}

		private void InsertParamListValueBool(int nPos,bool bValue)
		{
			string sInsert = bValue.ToString();
			ParamList.Items[nPos].SubItems[2].Text = sInsert;
		}

		private void InsertParamListValueLong(int nPos, long lValue)
		{
			string sInsert = lValue.ToString();
			ParamList.Items[nPos].SubItems[2].Text = sInsert;
		}

		private void InsertParamListValueString(int nPos, string sValue)
		{
			ParamList.Items[nPos].SubItems[2].Text = sValue;
		}

		private int GetParamListValueInt(int _nPos)
		{
			int nReturn = 0;
			try
			{
				nReturn = int.Parse(ParamList.Items[_nPos].SubItems[2].Text);
			}
			catch (Exception)
			{
			}

			return nReturn;
		}

		private ulong GetParamListValueUlong(int _nPos)
		{
			ulong ulReturn = 0;
			try
			{
				ulReturn = ulong.Parse(ParamList.Items[_nPos].SubItems[2].Text);
			}
			catch (Exception)
			{
			}

			return ulReturn;
		}

		private bool GetParamListValueBool(int _nPos)
		{
			bool bReturn = false;
			try
			{
				bReturn = bool.Parse(ParamList.Items[_nPos].SubItems[2].Text);
			}
			catch (Exception)
			{
			}

			return bReturn;
		}

		private void HideInputText()
		{
			m_TxtEdit.Visible = false;
			if (m_SelectedLSI != null) { m_SelectedLSI.Text = m_TxtEdit.Text; }
			m_SelectedLSI = null;
			m_TxtEdit.Text = "";
		}

		private void ResizeComponents()
		{
			// Command list
			CmdList.Left = 5;
			CmdList.Top = 5;
			CmdList.Width = 220;
			CmdList.Height = Form1.ActiveForm.Height - 45;
			// Command param list
			ParamList.Left = 230;
			ParamList.Top = 5;
			ParamList.Width = Form1.ActiveForm.Width - 250;
			ParamList.Height = 200;
			// Event list
			EventList.Left = 230;
			EventList.Top = 210;
			EventList.Width = Form1.ActiveForm.Width - 250;
			EventList.Height = Form1.ActiveForm.Height - 280;
			// Buttons
			BtnRun.Left = 230;
			BtnRun.Top = Form1.ActiveForm.Height - 65;
			BtnClear.Left = 310;
			BtnClear.Top = Form1.ActiveForm.Height - 65;
			BtnClose.Left = Form1.ActiveForm.Width - 95;
			BtnClose.Top = Form1.ActiveForm.Height - 65;
		}

		private void CmdList_SelectedIndexChanged(object sender, EventArgs e)
		{
			// Change selection
			string sSelectedCmd;
			sSelectedCmd = CmdList.Text;
			ParamList.Items.Clear();

			// Fill in parameters
			if (sSelectedCmd == "TMakeCall") 
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "TCallDrop")
			{
				InsertParamListItem(0, true, "lCallID", "LONG", "0");
			}
			else if (sSelectedCmd == "NPrepareRestart")
			{
				InsertParamListItem(0, true, "lMinutes", "LONG", "0");
			}
			else if (sSelectedCmd == "TCallAnswer")
			{
				InsertParamListItem(0, true, "lCallID", "LONG", "");
			}
			else if (sSelectedCmd == "TCallHold")
			{
				InsertParamListItem(0, true, "lCallID", "LONG", "");
			}
			else if (sSelectedCmd == "TCallUnHold")
			{
				InsertParamListItem(0, true, "lCallID", "LONG", "");
			}
			else if (sSelectedCmd == "ESendUserToUser")
			{
				InsertParamListItem(0, true, "bstrOther", "BSTR", "");
				InsertParamListItem(1, true, "bstrMessage", "BSTR", "");
			}
			else if (sSelectedCmd == "EUserSendToDataBase")
			{
				InsertParamListItem(0, true, "lCommand", "LONG", "");
				InsertParamListItem(1, true, "bstrMessage", "BSTR", "");
			}
			else if (sSelectedCmd == "TPickup")
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "TCallTransfer")
			{
				InsertParamListItem(0, true, "lCall1", "LONG", "");
				InsertParamListItem(1, true, "lCall2", "LONG", "");
			}
			else if (sSelectedCmd == "ESetMainWindow")
			{
				InsertParamListItem(0, true, "hWnd", "LONG", "");
			}
			else if (sSelectedCmd == "EChatStart")
			{
				InsertParamListItem(0, true, "bstrDest", "BSTR", "");
			}
			else if (sSelectedCmd == "EChatMessage")
			{
				InsertParamListItem(0, true, "bstrMessage", "BSTR", "");
			}
			else if (sSelectedCmd == "TAddCallToConference")
			{
				InsertParamListItem(0, true, "lCallID", "LONG", "");
			}
			else if (sSelectedCmd == "TAddNumberToConference")
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "EExpandInternNumber")
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
				InsertParamListItem(1, false, "pbstrReturn", "BSTR*", "");
			}
			else if (sSelectedCmd == "TProxyMakeCall")
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
				InsertParamListItem(1, true, "bstrProxy", "BSTR", "");
			}
			else if (sSelectedCmd == "ESetAcdReady")
			{
				InsertParamListItem(0, true, "bReady", "BOOL", "");
			}
			else if (sSelectedCmd == "SQLLogin")
			{
				InsertParamListItem(0, true, "bstrPwd", "BSTR", "");
			}
			else if (sSelectedCmd == "SQLBegin")
			{
				InsertParamListItem(0, true, "bstrCommand", "BSTR", "");
				InsertParamListItem(1, true, "dwCount", "ULONG", "");
				InsertParamListItem(2, false, "pdwRequest", "ULONG*", "");
			}
			else if (sSelectedCmd == "SQLNext")
			{
				InsertParamListItem(0, true, "dwRequest", "ULONG", "");
				InsertParamListItem(1, true, "dwCount", "ULONG", "");
				InsertParamListItem(2, false, "pbSuccess", "BOOL*", "");
			}
			else if (sSelectedCmd == "SQLEnd")
			{
				InsertParamListItem(0, true, "dwRequest", "ULONG", "");
			}
			else if (sSelectedCmd == "SQLGetDbBook")
			{
				InsertParamListItem(0, true, "bstrText", "BSTR", "");
			}
			else if (sSelectedCmd == "EConvertToCanonical")
			{
				InsertParamListItem(0, true, "bstrInput", "BSTR", "");
				InsertParamListItem(1, false, "bstrOut", "BSTR*", "");
			}
			else if (sSelectedCmd == "OConnectionIconOptions")
			{
				InsertParamListItem(0, true, "hIconOn", "ULONG", "");
				InsertParamListItem(1, true, "hIconOff", "ULONG", "");
				InsertParamListItem(2, true, "hMenu", "ULONG", "");
				InsertParamListItem(3, true, "bstrText", "BSTR", "");
			}
			else if (sSelectedCmd == "TCallRedirect")
			{
				InsertParamListItem(0, true, "lCallID", "LONG", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "TSendCallReminder")
			{
				InsertParamListItem(0, true, "bstrOther", "BSTR", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
				InsertParamListItem(2, true, "bstrMessage", "BSTR", "");
			}
			else if (sSelectedCmd == "TSetForwarding")
			{
				InsertParamListItem(0, true, "bSet", "BOOL", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "EGetFormatDateTime")
			{
				InsertParamListItem(0, true, "lTime", "LONG", "");
				InsertParamListItem(1, true, "bstrFormat", "BSTR", "");
				InsertParamListItem(2, false, "bstrTimeString", "BSTR*", "");
			}
			else if (sSelectedCmd == "EGetDateTime")
			{
				InsertParamListItem(0, true, "lTime", "LONG", "");
				InsertParamListItem(1, false, "bstrTimeString", "BSTR*", "");
			}
			else if (sSelectedCmd == "TCallAlternate")
			{
				InsertParamListItem(0, true, "lOldCall", "LONG", "");
				InsertParamListItem(1, true, "lNewCall", "LONG", "");
			}
			// Properties - bool
			else if (sSelectedCmd == "OShowIcon")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OShowIcon);
			}
			else if (sSelectedCmd == "OAutoConnect")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OAutoConnect);
			}
			else if (sSelectedCmd == "OAssistedTelephony")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OAssistedTelephony);
			}
			else if (sSelectedCmd == "OShowMenu")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OShowMenu);
			}
			else if (sSelectedCmd == "OAutoLogin")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OAutoLogin);
			}
			else if (sSelectedCmd == "OHotKey")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OHotKey);
			}
			else if (sSelectedCmd == "OPhoneIcon")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OPhoneIcon);
			}
			else if (sSelectedCmd == "OCheckConnection")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OCheckConnection);
			}
			else if (sSelectedCmd == "OAutoAnswer")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OAutoAnswer);
			}
			else if (sSelectedCmd == "OQuickMouseDial")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.OQuickMouseDial);
			}
			else if (sSelectedCmd == "EPrivateState")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.EPrivateState);
			}
			else if (sSelectedCmd == "NClientActive")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.NClientActive);
			}
			else if (sSelectedCmd == "TForwardingState")
			{
				InsertParamListItem(0, true, "bVal", "BOOL", "");
				InsertParamListValueBool(0, axFCTIClntCtrl1.TForwardingState);
			}
			// Properties - string
			else if (sSelectedCmd == "NServerName")
			{
				InsertParamListItem(0, true, "sVal", "BSTR", "");
				InsertParamListValueString(0, axFCTIClntCtrl1.NServerName);
			}
			else if (sSelectedCmd == "OIniFileName")
			{
				InsertParamListItem(0, false, "sVal", "BSTR", "");
				InsertParamListValueString(0, axFCTIClntCtrl1.OIniFileName);
			}
			else if (sSelectedCmd == "OOwnerNumber")
			{
				InsertParamListItem(0, true, "sVal", "BSTR", "");
				InsertParamListValueString(0, axFCTIClntCtrl1.OOwnerNumber);
			}
			else if (sSelectedCmd == "TForwardingDest")
			{
				InsertParamListItem(0, true, "sVal", "BSTR", "");
				InsertParamListValueString(0, axFCTIClntCtrl1.TForwardingDest);
			}
			else if (sSelectedCmd == "OOwnerName")
			{
				InsertParamListItem(0, true, "sVal", "BSTR", "");
				InsertParamListValueString(0, axFCTIClntCtrl1.OOwnerName);
			}
			else if (sSelectedCmd == "TRedialNumber")
			{
				InsertParamListItem(0, false, "sVal", "BSTR", "");
				InsertParamListValueString(0, axFCTIClntCtrl1.TRedialNumber);
			}
			// Properties - long
			else if (sSelectedCmd == "NPortNumber")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.NPortNumber);
			}
			else if (sSelectedCmd == "OOptions")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.OOptions);
			}
			else if (sSelectedCmd == "OUserCallInfo")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.OUserCallInfo);
			}
			else if (sSelectedCmd == "NClientCount")
			{
				InsertParamListItem(0, false, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.NClientCount);
			}
			else if (sSelectedCmd == "ODropSpecialKey")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.ODropSpecialKey);
			}
			else if (sSelectedCmd == "ODropKey")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.ODropKey);
			}
			else if (sSelectedCmd == "ODialSpecialKey")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.ODialSpecialKey);
			}
			else if (sSelectedCmd == "ODialKey")
			{
				InsertParamListItem(0, true, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.ODialKey);
			}
			else if (sSelectedCmd == "NumberOfInstances")
			{
				InsertParamListItem(0, false, "lVal", "LONG", "");
				InsertParamListValueLong(0, axFCTIClntCtrl1.NumberOfInstances);
			}
		}

		private void BtnClose_Click(object sender, EventArgs e)
		{
			// Close Program
			Close();
		}

		private void BtnRun_Click(object sender, EventArgs e)
		{
			// Get command
			string sSelectedCmd;
			sSelectedCmd = CmdList.Text;

			// Commands
			if (sSelectedCmd == "NStartClient")
			{
				axFCTIClntCtrl1.NStartClient();
			}
			else if (sSelectedCmd == "NStopClient")
			{
				axFCTIClntCtrl1.NStopClient();
			}
			else if (sSelectedCmd == "NNetworkConfigDialog")
			{
				axFCTIClntCtrl1.NNetworkConfigDialog();
			}
			else if (sSelectedCmd == "TMakeCall")
			{
				string sTarget = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.TMakeCall(sTarget);
			}
			else if (sSelectedCmd == "TCallDrop")
			{
				int nCallId = GetParamListValueInt(0);
				axFCTIClntCtrl1.TCallDrop(nCallId);
			}
			else if (sSelectedCmd == "TRemovePhoneIcon")
			{
				axFCTIClntCtrl1.TRemovePhoneIcon();
			}
			else if (sSelectedCmd == "TReDial")
			{
				axFCTIClntCtrl1.TReDial();
			}
			else if (sSelectedCmd == "NLogin")
			{
				axFCTIClntCtrl1.NLogin();
			}
			else if (sSelectedCmd == "NLogoff")
			{
				axFCTIClntCtrl1.NLogoff();
			}
			else if (sSelectedCmd == "NPrepareRestart")
			{
				int nMinutes = GetParamListValueInt(0);
				axFCTIClntCtrl1.NPrepareRestart(nMinutes);
			}
			else if (sSelectedCmd == "TCallAnswer")
			{
				int nCallId = GetParamListValueInt(0);
				axFCTIClntCtrl1.TCallAnswer(nCallId);
			}
			else if (sSelectedCmd == "TCallHold")
			{
				int nCallId = GetParamListValueInt(0);
				axFCTIClntCtrl1.TCallHold(nCallId);
			}
			else if (sSelectedCmd == "TCallUnHold")
			{
				int nCallId = GetParamListValueInt(0);
				axFCTIClntCtrl1.TCallUnHold(nCallId);
			}
			else if (sSelectedCmd == "ESendUserToUser")
			{
				string sOther = ParamList.Items[0].SubItems[2].Text;
				string sMessage = ParamList.Items[1].SubItems[2].Text;
				axFCTIClntCtrl1.ESendUserToUser(sOther, sMessage);
			}
			else if (sSelectedCmd == "EUserSendToDataBase")
			{
				int nCommand = GetParamListValueInt(0);
				string sText = ParamList.Items[1].SubItems[2].Text;
				axFCTIClntCtrl1.EUserSendToDataBase(nCommand, sText);
			}
			else if (sSelectedCmd == "TPickup")
			{
				string sNumber = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.TPickup(sNumber);
			}
			else if (sSelectedCmd == "EShowInfoDialog")
			{
				axFCTIClntCtrl1.EShowInfoDialog();
			}
			else if (sSelectedCmd == "TCallTransfer")
			{
				int nCall1 = GetParamListValueInt(0);
				int nCall2 = GetParamListValueInt(1);
				axFCTIClntCtrl1.TCallTransfer(nCall1, nCall2);
			}
			else if (sSelectedCmd == "ESetMainWindow")
			{
				ulong ulWnd = GetParamListValueUlong(0);
				axFCTIClntCtrl1.ESetMainWindow((uint)ulWnd);
			}
			else if (sSelectedCmd == "EChatStart")
			{
				string sDest = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.EChatStart(sDest);
			}
			else if (sSelectedCmd == "EChatEnd")
			{
				axFCTIClntCtrl1.EChatEnd();
			}
			else if (sSelectedCmd == "EChatMessage")
			{
				string sMessage = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.EChatMessage(sMessage);
			}
			else if (sSelectedCmd == "TAddCallToConference")
			{
				int nCallId = GetParamListValueInt(0);
				axFCTIClntCtrl1.TAddCallToConference(nCallId);
			}
			else if (sSelectedCmd == "TAddNumberToConference")
			{
				string sNumber = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.TAddNumberToConference(sNumber);
			}
			else if (sSelectedCmd == "EExpandInternNumber")
			{
				string sNumber = ParamList.Items[0].SubItems[2].Text;
				string sReturn = "";
				axFCTIClntCtrl1.EExpandInternNumber(sNumber, out sReturn);
				ParamList.Items[1].SubItems[2].Text = sReturn;
			}
			else if (sSelectedCmd == "TLineReset")
			{
				axFCTIClntCtrl1.TLineReset();
			}
			else if (sSelectedCmd == "TProxyMakeCall")
			{
				string sNumber = ParamList.Items[0].SubItems[2].Text;
				string sProxy = ParamList.Items[1].SubItems[2].Text;
				axFCTIClntCtrl1.TProxyMakeCall(sNumber, sProxy);
			}
			else if (sSelectedCmd == "ESetAcdReady")
			{
				bool bReady = GetParamListValueBool(0);
				axFCTIClntCtrl1.ESetAcdReady(bReady);
			}
			else if (sSelectedCmd == "SQLLogin")
			{
				string sPwd = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.SQLLogin(sPwd);
			}
			else if (sSelectedCmd == "SQLBegin")
			{
				string sCommand = ParamList.Items[0].SubItems[2].Text;
				uint uCount = (uint)GetParamListValueUlong(1);
				uint uRequest = 0;
				axFCTIClntCtrl1.SQLBegin(sCommand, uCount, out uRequest);
				ParamList.Items[2].SubItems[2].Text = uRequest.ToString();
			}
			else if (sSelectedCmd == "SQLNext")
			{
				ulong ulRequest = GetParamListValueUlong(0);
				ulong ulCount = GetParamListValueUlong(1);
				bool bSuccess = false;
				axFCTIClntCtrl1.SQLNext((uint)ulRequest, (uint)ulCount, out bSuccess);
				ParamList.Items[2].SubItems[2].Text = bSuccess.ToString();
			}
			else if (sSelectedCmd == "SQLEnd")
			{
				ulong ulRequest = GetParamListValueUlong(0);
				axFCTIClntCtrl1.SQLEnd((uint)ulRequest);
			}
			else if (sSelectedCmd == "SQLGetDbBook")
			{
				string sText = ParamList.Items[0].SubItems[2].Text;
				axFCTIClntCtrl1.SQLGetDbBook(sText);
			}
			else if (sSelectedCmd == "EConvertToCanonical")
			{
				string sText = ParamList.Items[0].SubItems[2].Text;
				string sOutput = "";
				axFCTIClntCtrl1.EConvertToCanonical(sText,out sOutput);
				ParamList.Items[1].SubItems[2].Text = sOutput;
			}
			else if (sSelectedCmd == "OConnectionIconOptions")
			{
				ulong ulIconOn = GetParamListValueUlong(0);
				ulong ulIconOff = GetParamListValueUlong(1);
				ulong ulMenu = GetParamListValueUlong(2);
				string sText = ParamList.Items[3].SubItems[2].Text;
				axFCTIClntCtrl1.OConnectionIconOptions((uint)ulIconOn, (uint)ulIconOff, (uint)ulMenu, sText);
			}
			else if (sSelectedCmd == "TCallRedirect")
			{
				int nCallId = GetParamListValueInt(0);
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				axFCTIClntCtrl1.TCallRedirect(nCallId, sNumber);
			}
			else if (sSelectedCmd == "TSendCallReminder")
			{
				string sOther = ParamList.Items[0].SubItems[2].Text;
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				string sMessage = ParamList.Items[2].SubItems[2].Text;
				axFCTIClntCtrl1.TSendCallReminder(sOther, sNumber, sMessage);
			}
			else if (sSelectedCmd == "TSetForwarding")
			{
				bool bSet = GetParamListValueBool(0);
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				axFCTIClntCtrl1.TSetForwarding(bSet, sNumber);
			}
			else if (sSelectedCmd == "EGetFormatDateTime")
			{
				int nTime = GetParamListValueInt(0);
				string sFormat = ParamList.Items[1].SubItems[2].Text;
				string sTimeString = "";
				axFCTIClntCtrl1.EGetFormatDateTime(nTime, sFormat, out sTimeString);
				ParamList.Items[2].SubItems[2].Text = sTimeString;
			}
			else if (sSelectedCmd == "EGetDateTime")
			{
				int nTime = GetParamListValueInt(0);
				string sTimeString = "";
				axFCTIClntCtrl1.EGetDateTime(nTime, out sTimeString);
				ParamList.Items[1].SubItems[2].Text = sTimeString;
			}
			else if (sSelectedCmd == "TCallAlternate")
			{
				int nCall1 = GetParamListValueInt(0);
				int nCall2 = GetParamListValueInt(1);
				axFCTIClntCtrl1.TCallAlternate(nCall1, nCall2);
			}

			// Properties
			else if (sSelectedCmd == "OShowIcon")
			{
				axFCTIClntCtrl1.OShowIcon = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OAutoConnect")
			{
				axFCTIClntCtrl1.OAutoConnect = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OShowMenu")
			{
				axFCTIClntCtrl1.OShowMenu = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OAutoLogin")
			{
				axFCTIClntCtrl1.OAutoLogin = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OHotKey")
			{
				axFCTIClntCtrl1.OHotKey = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OPhoneIcon")
			{
				axFCTIClntCtrl1.OPhoneIcon = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OCheckConnection")
			{
				axFCTIClntCtrl1.OCheckConnection = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OAutoAnswer")
			{
				axFCTIClntCtrl1.OAutoAnswer = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "OQuickMouseDial")
			{
				axFCTIClntCtrl1.OQuickMouseDial = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "EPrivateState")
			{
				axFCTIClntCtrl1.EPrivateState = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "NClientActive")
			{
				axFCTIClntCtrl1.NClientActive = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "NServerName")
			{
				axFCTIClntCtrl1.NServerName = ParamList.Items[0].SubItems[2].Text;
			}
			else if (sSelectedCmd == "NPortNumber")
			{
				axFCTIClntCtrl1.NPortNumber = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "OOwnerNumber")
			{
				axFCTIClntCtrl1.OOwnerNumber = ParamList.Items[0].SubItems[2].Text;
			}
			else if (sSelectedCmd == "OOptions")
			{
				axFCTIClntCtrl1.OOptions = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "OUserCallInfo")
			{
				axFCTIClntCtrl1.OUserCallInfo = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "ODropSpecialKey")
			{
				axFCTIClntCtrl1.ODropSpecialKey = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "ODropKey")
			{
				axFCTIClntCtrl1.ODropKey = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "ODialSpecialKey")
			{
				axFCTIClntCtrl1.ODialSpecialKey = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "ODialKey")
			{
				axFCTIClntCtrl1.ODialKey = GetParamListValueInt(0);
			}
			else if (sSelectedCmd == "TForwardingState")
			{
				axFCTIClntCtrl1.TForwardingState = GetParamListValueBool(0);
			}
			else if (sSelectedCmd == "TForwardingDest")
			{
				axFCTIClntCtrl1.TForwardingDest = ParamList.Items[0].SubItems[2].Text;
			}
			else if (sSelectedCmd == "OOwnerName")
			{
				axFCTIClntCtrl1.OOwnerName = ParamList.Items[0].SubItems[2].Text;
			}// if (sSelectedCmd == 
		}

		private void ParamList_MouseUp(object sender, MouseEventArgs e)
		{
			// Get selection
			ListViewHitTestInfo Info = ParamList.HitTest(e.X, e.Y);
			m_SelectedLSI = Info.SubItem;
			if (m_SelectedLSI == null) { return; }
			m_nSelPos = ParamList.Items.IndexOf(Info.Item);
			if (m_nSelPos < 0) { return; }
			m_nSubPos = ParamList.Items[m_nSelPos].SubItems.IndexOf(Info.SubItem);
			if (m_nSubPos < 2) { return; }
			Color cTest = Info.SubItem.BackColor;
			if (cTest != System.Drawing.Color.Beige) { return; }

			int nBorder = 0;
			switch (ParamList.BorderStyle)
			{
				case BorderStyle.FixedSingle:
					{
						nBorder = 1;
						break;
					}
				case BorderStyle.Fixed3D:
					{
						nBorder = 2;
						break;
					}
			}// switch (ParamList.BorderStyle)

			// Size of new edit box
			int nCellWidth = m_SelectedLSI.Bounds.Width;
			int nCellHeight = m_SelectedLSI.Bounds.Height;
			int nCellLeft = nBorder + ParamList.Left + Info.SubItem.Bounds.Left;
			int nCellTop = ParamList.Top + Info.SubItem.Bounds.Top;

			m_TxtEdit.Location = new Point(nCellLeft, nCellTop);
			m_TxtEdit.Size = new Size(nCellWidth, nCellHeight);
			m_TxtEdit.Visible = true;
			m_TxtEdit.BringToFront();
			m_TxtEdit.Text = Info.SubItem.Text;
			m_TxtEdit.Select();
			m_TxtEdit.SelectAll();
		}

		private void m_TxtEdit_Leave(object sender, EventArgs e)
		{
			HideInputText();
		}

		private void m_TxtEdit_KeyUp(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) { HideInputText(); }
		}

		private void BtnClear_Click(object sender, EventArgs e)
		{
			EventList.Items.Clear();
		}

		private void axFCTIClntCtrl1_OnConnectionState(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnConnectionStateEvent e)
		{
			InsertEventListItem("OnConnectionState", "State", "int", e.lState.ToString());
		}

		private void axFCTIClntCtrl1_OnCallState(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnCallStateEvent e)
		{
			InsertEventListItem("OnCallState", "State", "int", e.lState.ToString());
			InsertEventListItem("", "CallID", "long", e.lCallID.ToString());
		}

		private void axFCTIClntCtrl1_OnCallNumber(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnCallNumberEvent e)
		{
			InsertEventListItem("OnCallNumber", "Type", "int", e.lType.ToString());
			InsertEventListItem("", "CallID", "long", e.lCallID.ToString());
			InsertEventListItem("", "CallID", "string", e.bstrNumber);
		}

		private void axFCTIClntCtrl1_OnShowPhoneList(object sender, EventArgs e)
		{
			InsertEventListItem("OnShowPhoneList", "empty", "void", "");
		}

		private void axFCTIClntCtrl1_OnLogin(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnLoginEvent e)
		{
			InsertEventListItem("OnLogin", "Success", "bool", e.bSuccess.ToString());
		}

		private void axFCTIClntCtrl1_OnMenuCommand(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnMenuCommandEvent e)
		{
			InsertEventListItem("OnMenuCommand", "Command", "ushort", e.wCommand.ToString());
		}

		private void axFCTIClntCtrl1_OnServerMessage(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnServerMessageEvent e)
		{
			InsertEventListItem("OnServerMessage", "Message", "string", e.bstrMessage);
		}

		private void axFCTIClntCtrl1_OnClientClose(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnClientCloseEvent e)
		{
			InsertEventListItem("OnClientClose", "Minutes", "int", e.lMinutes.ToString());
		}

		private void axFCTIClntCtrl1_OnInvalidStringFormat(object sender, EventArgs e)
		{
			InsertEventListItem("OnInvalidStringFormat", "empty", "void", "");
		}

		private void axFCTIClntCtrl1_OnProtocolData(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnProtocolDataEvent e)
		{
			InsertEventListItem("OnProtocolData", "Other", "string", e.bstrOther);
			InsertEventListItem("", "Own", "string", e.bstrOwn);
			InsertEventListItem("", "Start", "int", e.lStart.ToString());
			InsertEventListItem("", "End", "int", e.lEnd.ToString());
			InsertEventListItem("", "Success", "bool", e.bSuccess.ToString());
			InsertEventListItem("", "Inbound", "bool", e.bInbound.ToString());
		}

		private void axFCTIClntCtrl1_OnUserToUser(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnUserToUserEvent e)
		{
			InsertEventListItem("OnUserToUser", "Other", "string", e.bstrOther);
			InsertEventListItem("", "Message", "string", e.bstrMessage);
		}

		private void axFCTIClntCtrl1_OnDatabaseToUser(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnDatabaseToUserEvent e)
		{
			InsertEventListItem("OnDatabaseToUser", "Command", "int", e.lCommand.ToString());
			InsertEventListItem("", "Message", "string", e.bstrMessage);
		}

		private void axFCTIClntCtrl1_OnGroupMember(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnGroupMemberEvent e)
		{
			InsertEventListItem("OnGroupMember", "Number", "string", e.bstrNumber);
			InsertEventListItem("", "Name", "string", e.bstrName);
			InsertEventListItem("", "Online", "bool", e.bOnline.ToString());
			InsertEventListItem("", "ActiveCall", "bool", e.bActiveCall.ToString());
			InsertEventListItem("", "Offerings", "bool", e.bOfferings.ToString());
			InsertEventListItem("", "Redirection", "bool", e.bRedirection.ToString());
		}

		private void axFCTIClntCtrl1_OnSendUserState(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnSendUserStateEvent e)
		{
			InsertEventListItem("OnSendUserState", "Number", "string", e.bstrNumber);
			InsertEventListItem("", "Login", "bool", e.bLogin.ToString());
			InsertEventListItem("", "ActiveCall", "bool", e.bActiveCall.ToString());
			InsertEventListItem("", "Offerings", "bool", e.bOfferings.ToString());
			InsertEventListItem("", "Redirection", "bool", e.bRedirection.ToString());
		}

		private void axFCTIClntCtrl1_OnChatStart(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnChatStartEvent e)
		{
			InsertEventListItem("OnChatStart", "StartOK", "bool", e.bStartOK.ToString());
			InsertEventListItem("", "User", "string", e.bstrUser);
		}

		private void axFCTIClntCtrl1_OnChatStop(object sender, EventArgs e)
		{
			InsertEventListItem("OnChatStop", "empty", "void", "");
		}

		private void axFCTIClntCtrl1_OnChatMessage(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnChatMessageEvent e)
		{
			InsertEventListItem("OnChatMessage", "Message", "string", e.bstrMessage);
		}

		private void axFCTIClntCtrl1_OnSQLLogin(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnSQLLoginEvent e)
		{
			InsertEventListItem("OnSQLLogin", "StartOK", "bool", e.bSuccess.ToString());
		}

		private void axFCTIClntCtrl1_OnSQLData(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnSQLDataEvent e)
		{
			InsertEventListItem("OnSQLData", "Request", "uint", e.dwRequest.ToString());
			InsertEventListItem("", "Count", "int", e.lCount.ToString());
			InsertEventListItem("", "Data", "string", e.bstrData);
		}

		private void axFCTIClntCtrl1_OnSQLEnd(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnSQLEndEvent e)
		{
			InsertEventListItem("OnSQLEnd", "Request", "uint", e.dwRequest.ToString());
			InsertEventListItem("", "Success", "bool", e.bSuccess.ToString());
		}

		private void axFCTIClntCtrl1_OnDbBookRecord(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnDbBookRecordEvent e)
		{
			InsertEventListItem("OnDbBookRecord", "Name", "string", e.bstrName);
			InsertEventListItem("", "Number", "string", e.bstrNumber);
			InsertEventListItem("", "Extra", "string", e.bstrExtra);
		}

		private void axFCTIClntCtrl1_OnSendAddress(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnSendAddressEvent e)
		{
			InsertEventListItem("OnSendAddress", "IsAddress", "bool", e.bIsAddress.ToString());
			InsertEventListItem("", "CallID", "int", e.lCallID.ToString());
			InsertEventListItem("", "Address", "string", e.bstrAddress);
		}

		private void axFCTIClntCtrl1_OnRaiseClient(object sender, EventArgs e)
		{
			InsertEventListItem("OnRaiseClient", "empty", "void", "");
		}

		private void axFCTIClntCtrl1_OnObjectOfRedirect(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnObjectOfRedirectEvent e)
		{
			InsertEventListItem("OnObjectOfRedirect", "Set", "bool", e.bSet.ToString());
			InsertEventListItem("", "Number", "string", e.bstrNumber);
		}

		private void axFCTIClntCtrl1_OnConfNotify(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnConfNotifyEvent e)
		{
			InsertEventListItem("OnConfNotify", "Conf", "bool", e.bConf.ToString());
		}

		private void axFCTIClntCtrl1_OnLicenseInfo(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnLicenseInfoEvent e)
		{
			InsertEventListItem("OnLicenseInfo", "Text", "string", e.bstrText);
		}

		private void axFCTIClntCtrl1_OnIdentity(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnIdentityEvent e)
		{
			InsertEventListItem("OnIdentity", "CallID", "int", e.lCallID.ToString());
			InsertEventListItem("", "Name", "string", e.bstrName);
		}

		private void axFCTIClntCtrl1_OnLocaleInfo(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnLocaleInfoEvent e)
		{
			InsertEventListItem("OnLocaleInfo", "InternLength", "int", e.lInternLength.ToString());
			InsertEventListItem("", "Country", "int", e.lCountry.ToString());
			InsertEventListItem("", "City", "string", e.bstrCity);
			InsertEventListItem("", "PBX", "string", e.bstrPBX);
		}

		private void axFCTIClntCtrl1_OnCallReminder(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnCallReminderEvent e)
		{
			InsertEventListItem("OnCallReminder", "User", "string", e.bstrUser);
			InsertEventListItem("", "Number", "string", e.bstrNumber);
			InsertEventListItem("", "Message", "string", e.bstrMessage);
		}

		private void axFCTIClntCtrl1_OnForwardingState(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnForwardingStateEvent e)
		{
			InsertEventListItem("OnForwardingState", "Set", "int", e.bSet.ToString());
			InsertEventListItem("", "Number", "string", e.bstrNumber);
		}

		private void axFCTIClntCtrl1_OnAcdCancelClient(object sender, EventArgs e)
		{
			InsertEventListItem("OnAcdCancelClient", "empty", "void", "");
		}

		private void axFCTIClntCtrl1_OnTransferPendInfo(object sender, AxFCTICLNTLib._IFCTIClntCtrlEvents_OnTransferPendInfoEvent e)
		{
			InsertEventListItem("OnTransferPendInfo", "Member", "string", e.bstrMember);
			InsertEventListItem("", "HeldParty", "string", e.bstrHeldParty);
		}

	}
}
