//***************************************************************************************
#include "stdafx.h"
#include "IPSend.h"
#include "IPSendDlg.h"
#include ".\ipsenddlg.h"
//***************************************************************************************
#ifdef _DEBUG
#define new DEBUG_NEW
#endif 
//***************************************************************************************
// CIPSendDlg Dialog

CIPSendDlg::CIPSendDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIPSendDlg::IDD, pParent)
	, m_dwPort(0)
	, m_szOwnNumber(_T(""))
	, m_szDestNumber(_T(""))
	, m_szIPAddress(_T("127.0.0.1"))
	, m_CommandList()
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}
//***************************************************************************************

void CIPSendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_dwPort);
	DDX_Text(pDX, IDC_EDIT2, m_szOwnNumber);
	DDX_Text(pDX, IDC_EDIT3, m_szDestNumber);
	DDX_Text(pDX, IDC_EDIT4, m_szIPAddress);
	DDX_Text(pDX, IDC_EDIT5, m_szProxy);
	DDV_MinMaxUInt(pDX, m_dwPort, 0, 65000);
	DDV_MaxChars(pDX, m_szOwnNumber, 4);
	DDV_MaxChars(pDX, m_szProxy, 4);
	DDV_MaxChars(pDX, m_szDestNumber, 31);
	DDV_MaxChars(pDX, m_szIPAddress, 31);
	DDX_Control(pDX, IDC_COMMAND, m_CommandList);
}
//***************************************************************************************
BEGIN_MESSAGE_MAP(CIPSendDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
END_MESSAGE_MAP()
//***************************************************************************************
// CIPSendDlg init

BOOL CIPSendDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	ShowWindow(SW_NORMAL);

	UpdateData(FALSE);

	m_CommandList.SetCurSel(0);
	
	return TRUE;
}
//***************************************************************************************

// Send over stream Socket
void CIPSendDlg::OnBnClickedButton1()
{
	// Variables
	WSADATA WsaData = {0,0,"","",0,0,NULL};
	struct sockaddr_in SockAddrIn = {0,0,0,0};
	int nError = 0;
	BOOL bWSAInit = TRUE;
	SOCKET wSocket = 0;

	// Read dialog values
	UpdateData();

	// Prepare data
	TCHAR szSendBuffer[64] = _T("");
	int nSelected = m_CommandList.GetCurSel();
	CString szSelectedCommand;
	m_CommandList.GetLBText(nSelected,szSelectedCommand);
	StringCchPrintf(szSendBuffer,64,_T("%s %s %s %s"),
		szSelectedCommand.GetBuffer(),
		m_szOwnNumber.GetBuffer(),
		m_szProxy.GetBuffer(),
		m_szDestNumber.GetBuffer());
	DWORD dwLen = (DWORD)_tcslen(szSendBuffer) + 1;

	// Initialize TCP / IP
	nError = WSAStartup(MAKEWORD(2,2),&WsaData);
	if(nError){bWSAInit = FALSE;}

	// Open socket
	wSocket = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	if(wSocket == INVALID_SOCKET)
	{
		if(bWSAInit){WSACleanup();}
		return;
	}// if(wSocket == INVALID_SOCKET)

	// Open connection
	SockAddrIn.sin_family = AF_INET;
	SockAddrIn.sin_port = htons((WORD)m_dwPort);
	SockAddrIn.sin_addr.S_un.S_addr = inet_addr(m_szIPAddress.GetBuffer());
	WSASetLastError(0);
	nError = connect(wSocket,(SOCKADDR*)&SockAddrIn,sizeof(SockAddrIn));
	if(nError == SOCKET_ERROR)
	{
		// Error check, WSAEWOULDBLOCK is not an error
		nError = WSAGetLastError();
		switch(nError)
		{
		case WSAEWOULDBLOCK:
		case ERROR_ALREADY_EXISTS:{break;}
		default:
			{
				closesocket(wSocket);
				if(bWSAInit){WSACleanup();}
				return;
			}
		}// switch(nError)
	}// if(nError == SOCKET_ERROR)
	
	// Send data
	WSASetLastError(0);
	nError = send(wSocket,(PCHAR)szSendBuffer,dwLen,0);
	if(nError == SOCKET_ERROR)
	{
		nError = WSAGetLastError();
	}// if(nError == SOCKET_ERROR)
	Sleep(100);

	// Tidi up
	closesocket(wSocket);
	if(bWSAInit){WSACleanup();}
}
//***************************************************************************************

// Send over datagramm socket
void CIPSendDlg::OnBnClickedButton2()
{
	// Variables
	WSADATA WsaData = {0,0,"","",0,0,NULL};
	struct sockaddr_in SockAddrIn = {0,0,0,0};
	int nError = 0;
	BOOL bWSAInit = TRUE;
	SOCKET wSocket = 0;

	// Read dialog values
	UpdateData();

	// Prepare data
	TCHAR szSendBuffer[64] = _T("");
	int nSelected = m_CommandList.GetCurSel();
	CString szSelectedCommand;
	m_CommandList.GetLBText(nSelected,szSelectedCommand);
	StringCchPrintf(szSendBuffer,64,_T("%s %s %s %s"),
		szSelectedCommand.GetBuffer(),
		m_szOwnNumber.GetBuffer(),
		m_szProxy.GetBuffer(),
		m_szDestNumber.GetBuffer());
	DWORD dwLen = (DWORD)_tcslen(szSendBuffer) + 1;

	// Initialize TCP / IP
	nError = WSAStartup(MAKEWORD(2,2),&WsaData);
	if(nError){bWSAInit = FALSE;}

	// Open socket
	wSocket = socket(AF_INET,SOCK_DGRAM,IPPROTO_IP);
	if(wSocket == INVALID_SOCKET)
	{
		if(bWSAInit){WSACleanup();}
		return;
	}// if(wSocket == INVALID_SOCKET)

	// Prepare sending
	SockAddrIn.sin_family = AF_INET;
	SockAddrIn.sin_port = htons((WORD)m_dwPort);
	SockAddrIn.sin_addr.S_un.S_addr = inet_addr(m_szIPAddress.GetBuffer());

	// Send
	WSASetLastError(0);
	nError = sendto(wSocket,(PCHAR)szSendBuffer,dwLen,0,(const sockaddr*)&SockAddrIn,
		sizeof(SockAddrIn));
	if(nError == SOCKET_ERROR)
	{
		nError = WSAGetLastError();
	}// if(nError == SOCKET_ERROR)

	// Tidi up
	closesocket(wSocket);
	if(bWSAInit){WSACleanup();}
}
//***************************************************************************************
