//***************************************************************************************
// CTI-SDK: C++ Client interface for CTI
// Copyright  2001 - 2024 Tino Kasubke
//***************************************************************************************
#ifndef __FCTICLNT_H__
#define __FCTICLNT_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
//***************************************************************************************
// Include lib
#ifndef _USRDLL
#pragma comment(lib,"FCTICLNT")
#endif
//***************************************************************************************
// Function pointer
typedef VOID (__stdcall *InfoParentProc)(DWORD,WPARAM,LPARAM);
//***************************************************************************************
// Exported functions
//***************************************************************************************

// Options
DWORD WINAPI CTI_OGetOptions();
VOID WINAPI CTI_OSetOptions(DWORD,DWORD);
DWORD WINAPI CTI_OGetUserCallInfo();
VOID WINAPI CTI_OSetUserCallInfo(DWORD);
VOID WINAPI CTI_OConnectionIconOptions(HICON,HICON,HMENU,PTCHAR);
LONG WINAPI CTI_OGetDialKey();
VOID WINAPI CTI_OSetDialKey(LONG,DWORD _dwSpecialKey = 2);
LONG WINAPI CTI_OGetDropKey();
VOID WINAPI CTI_OSetDropKey(LONG,DWORD _dwSpecialKey = 2);
LONG WINAPI CTI_OGetAnswerKey();
VOID WINAPI CTI_OSetAnswerKey(LONG, DWORD _dwSpecialKey = 2);
PTCHAR WINAPI CTI_OGetIniFileName();
PTCHAR WINAPI CTI_OGetOwnerNumber();
VOID WINAPI CTI_OSetOwnerNumber(PTCHAR);
PTCHAR WINAPI CTI_OGetOwnerName();
VOID WINAPI CTI_OSetOwnerName(PTCHAR);

// Network
PTCHAR WINAPI CTI_NGetServerName();
VOID WINAPI CTI_NSetServerName(PTCHAR);
LONG WINAPI CTI_NGetPortNumber();
VOID WINAPI CTI_NSetPortNumber(LONG);
VOID WINAPI CTI_NSetNetworkOptions(PDWORD,PTCHAR);
VOID WINAPI CTI_NNetworkConfigDialog();
VOID WINAPI CTI_NClientStop();
VOID WINAPI CTI_NClientRestart();
VOID WINAPI CTI_NLogin();
VOID WINAPI CTI_NLogoff();
VOID WINAPI CTI_NPrepareRestart(LONG);
BOOL WINAPI CTI_NClientActive();
BOOL WINAPI CTI_NIsNetworkVersion();
DWORD WINAPI CTI_NGetClientCount();
VOID WINAPI CTI_NStartClientHWND(HWND);
VOID WINAPI CTI_NStartClientCALLBACK(InfoParentProc);

// Telephony
VOID WINAPI CTI_TMakeCall(PTCHAR);
VOID WINAPI CTI_TProxyMakeCall(PTCHAR,PTCHAR);
VOID WINAPI CTI_TCallAnswer(LONG);
VOID WINAPI CTI_TCallDrop(LONG);
VOID WINAPI CTI_TReDial();
VOID WINAPI CTI_TCallRedirect(LONG,PTCHAR);
VOID WINAPI CTI_TCallHold(LONG);
VOID WINAPI CTI_TCallUnHold(LONG);
PTCHAR WINAPI CTI_TGetForwardingDest();
BOOL WINAPI CTI_TGetForwardingState();
VOID WINAPI CTI_TSetForwarding(BOOL,PTCHAR _pszNumber = _T(""));
VOID WINAPI CTI_TRemovePhoneIcon();
VOID WINAPI CTI_TPickup(PTCHAR);
VOID WINAPI CTI_TSendCallReminder(PTCHAR,PTCHAR,PTCHAR _pszInfo = NULL);
VOID WINAPI CTI_TCallToggle(LONG,LONG);
VOID WINAPI CTI_TCallTransfer(LONG,LONG);
VOID WINAPI CTI_TAddCallToConference(LONG);
VOID WINAPI CTI_TAddNumberToConference(PTCHAR);
VOID WINAPI CTI_TLineReset();

// Additional functions
VOID WINAPI CTI_ESendUserToUser(PTCHAR,PTCHAR);
VOID WINAPI CTI_EUserSendToDataBase(LONG,PTCHAR);
VOID WINAPI CTI_EShowInfoDialog();
VOID WINAPI CTI_ESetAcdReady(BOOL);
VOID WINAPI CTI_ESetMainWindow(HWND);
VOID WINAPI CTI_EChatStart(PTCHAR);
VOID WINAPI CTI_EChatEnd();
VOID WINAPI CTI_EChatMessage(PTCHAR);
PTCHAR WINAPI CTI_EExpandInternNumber(PTCHAR);
VOID WINAPI CTI_EConvertToCanonical(PTCHAR,PTCHAR);
VOID WINAPI CTI_ESetPrivateState(BOOL);
BOOL WINAPI CTI_EGetPrivateState();
PTCHAR WINAPI CTI_EGetFormatDateTime(__time32_t,PTCHAR);
PTCHAR WINAPI CTI_EGetDateTime(__time32_t);

// SQL functions
VOID WINAPI CTI_SQLLogin(PTCHAR);
DWORD WINAPI CTI_SQLBegin(PTCHAR,DWORD);
BOOL WINAPI CTI_SQLNext(DWORD,DWORD);
VOID WINAPI CTI_SQLEnd(DWORD);
VOID WINAPI CTI_SQLGetDbBook(PTCHAR);
VOID WINAPI CTI_SQLInsertDataRecord(PTCHAR);
VOID WINAPI CTI_SQLDeleteDataRecord(PTCHAR);

// Internal functions
int WINAPI CTI_InputDialog(int,int,PTCHAR);
SOCKET WINAPI CTI_GetSocket();
VOID WINAPI CTI_TranslateMsgStruct(WPARAM,PDWORD,PDWORD,WPARAM*,LPARAM*,PTCHAR,PTCHAR,PTCHAR);
VOID WINAPI CTI_TranslateDataStruct(WPARAM,PDWORD,PDWORD,PDWORD,PDWORD,PDWORD,PTCHAR,PTCHAR,PTCHAR,PTCHAR);
BOOL WINAPI CTI_PrivateReady();
BOOL WINAPI CTI_SetOptionsEx(DWORD,DWORD);
PTCHAR WINAPI CTI_GetLastNumber();
PTCHAR WINAPI CTI_GetStartAppPath();
PTCHAR WINAPI CTI_GetStartAppParam();
DWORD WINAPI CTI_GetNumberOfInstances();
BOOL WINAPI DLL_DemoGetEscState();
VOID WINAPI DLL_DemoResetEscState();
VOID WINAPI DLL_BeforeClose();
VOID WINAPI DLL_SaveSettings();
//***************************************************************************************
#endif
//***************************************************************************************