//***************************************************************************************
#include "stdafx.h"
void MangleData(char* _pszInput,char _cStart)
{
	char cXorer = _cStart;
	while(*_pszInput)
	{
		cXorer++;
		cXorer %= 8;
		char cBack = *_pszInput;
		cBack ^= cXorer;
		*_pszInput = cBack;
		_pszInput++;
	}// _pszInput;
}
//*************************************************************************************************

// Als 16Bit Text eingelesene Werte komprimieren
void Transform2ByteToChar(char* _pszSource)
{
	// Tatschliche Lnge des Strings im Ziel
	long lDestLen = (long)strlen(_pszSource);
	lDestLen /= 2;
	if(!lDestLen){return;}

	// Zeichenweise komprimieren
	char* pszDest = _pszSource;
	DWORD c = 0;
	for(long l = 0;l < lDestLen;l++)
	{
		_stscanf_s(_pszSource,"%2x",&c);
		_pszSource += 2;
		*pszDest = (char)c;
		pszDest++;
	}// for(long l = 0;l < lDestLen;l++)
	*pszDest = 0;
}
VOID TransformCharTo2Byte(PTCHAR _pszSource)
{
	TCHAR szReturn[1024] = _T("");
	TCHAR szAdd[8] = _T("");
	PTCHAR pszSource = _pszSource;
	while(*pszSource)
	{
		StringCchPrintf(szAdd,7,_T("%02x"),*pszSource);
		StringCchCat(szReturn,1023,szAdd);
		pszSource++;
	}// while(*pszSource)
	StringCchCopy(_pszSource,1023,szReturn);
}
//***************************************************************************************

// Main function
int APIENTRY _tWinMain(HINSTANCE _hInstance,HINSTANCE,LPTSTR,int)
{
	DebugTrace(_T("_tWinMain"));
	g_hInstance = _hInstance;

	INITCOMMONCONTROLSEX commex = {0};
	commex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	commex.dwICC = ICC_LISTVIEW_CLASSES | ICC_TAB_CLASSES | ICC_STANDARD_CLASSES;
	InitCommonControlsEx(&commex);

	static TCHAR szData[2048] = _T("494c4161");
	Transform2ByteToChar(szData);
	MangleData(szData,3);
	MangleData(szData,3);
	TransformCharTo2Byte(szData);
	DebugTrace(_T(" #1"));

	// Initialize CTI Server interface
	CTI_Init(DataCallback);
	DebugTrace(_T(" #2"));

	// Show Main Dialog
	DialogBox(g_hInstance,MAKEINTRESOURCE(IDD_DIALOG1),0,TestDlgProc);
	DebugTrace(_T(" #3"));

	return 0;
}
//***************************************************************************************

// Main Dialog
INT_PTR WINAPI TestDlgProc(HWND _hWnd,
	UINT _wCommand,
	WPARAM _wParam,
	LPARAM _lParam)
{
	static LPNMHDR lpNmHeader = NULL;
	switch (_wCommand)
	{
	case WM_INITDIALOG:
	{
		DebugTrace(_T("WM_INITDIALOG"));
		// Get windows
		g_hDlg = _hWnd;
		g_hWndTab = GetDlgItem(_hWnd, IDC_TAB);
		g_hWndPage1 = CreateDialog(g_hInstance, MAKEINTRESOURCE(IDD_PAGE1),
			g_hWndTab, Page1DlgProc);
		g_hWndPage2 = CreateDialog(g_hInstance, MAKEINTRESOURCE(IDD_PAGE2),
			g_hWndTab, Page2DlgProc);
		g_hEventList = GetDlgItem(_hWnd, IDC_EVENTLIST);

		// Insert Tabs
		TCITEM strTCE = { 0 };
		strTCE.mask = TCIF_TEXT;
		strTCE.pszText = g_szPage1;
		TabCtrl_InsertItem(g_hWndTab, 0, &strTCE);
		strTCE.pszText = g_szPage2;
		TabCtrl_InsertItem(g_hWndTab, 1, &strTCE);
		GetClientRect(g_hWndTab, &g_TabRect);
		MoveWindow(g_hWndPage1, 1, 21, g_TabRect.right - 5, g_TabRect.bottom - 23, TRUE);
		MoveWindow(g_hWndPage2, 1, 21, g_TabRect.right - 5, g_TabRect.bottom - 23, TRUE);

		break;
	}// case WM_INITDIALOG
	case WM_COMMAND:
	{
		DebugTrace(_T("WM_COMMAND"));
		switch (LOWORD(_wParam))
		{
		case IDC_CLEAR:
		{
			SendMessage(g_hEventList, LB_RESETCONTENT, 0, 0);
			break;
		}// case IDC_CLEAR
		case IDOK:
		case IDCANCEL:
		{
			EndDialog(_hWnd, LOWORD(_wParam));
			break;
		}// case IDCANCEL
		}// switch(LOWORD(_wParam))
		break;
	}// case WM_COMMAND
	case WM_NOTIFY:
	{
		DebugTrace(_T("WM_NOTIFY"));
		lpNmHeader = (LPNMHDR)_lParam;
		if (lpNmHeader->idFrom == IDC_TAB)
		{
			if (lpNmHeader->code == TCN_SELCHANGE)
			{
				int nPage = TabCtrl_GetCurSel(g_hWndTab);
				switch (nPage)
				{
				case 0:
				{
					ShowWindow(g_hWndPage1, SW_SHOW);
					ShowWindow(g_hWndPage2, SW_HIDE);
					break;
				}// case 0
				case 1:
				{
					ShowWindow(g_hWndPage1, SW_HIDE);
					ShowWindow(g_hWndPage2, SW_SHOW);
					break;
				}// case 1
				}// switch(nPage)
			}// if(lpNmHeader->code == TCN_SELCHANGE)
		}// if(lpNmHeader->idFrom == IDC_TAB)
		break;
	}// case WM_NOTIFY
	}// switch(_wCommand)

	return DefDlgProc(_hWnd,_wCommand, _wParam, _lParam);
}
//***************************************************************************************

// Command list page
INT_PTR WINAPI Page1DlgProc(HWND _hWnd,
	UINT _wCommand,
	WPARAM _wParam,
	LPARAM)
{
	switch(_wCommand)
	{
	case WM_INITDIALOG:
		{
			// Insert Commands
			HWND hList = GetDlgItem(_hWnd,IDC_CMDLIST);
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("---------------------------"));
			// Initial functions
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Init"));
			// Call functions
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Alternate"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Answer"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Conference"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Drop"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Forward"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("MakeCall"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Pickup"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Redirect"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("SetPhoneDisplay"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("Transfer"));
			// Message functions
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("SendAdminMessage"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("SendIdentity"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("SendUserData"));
			// Transformation functions
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("ConvertToCanonical"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetDateTime"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetFormatDateTime"));
			// Information functions
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetLicenseCount"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetNameFromExtension"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetPBXFilters"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetPBXMonitoredLines"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetTMServiceStatus"));
			// Event trigger functions
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetAllUserCallStates"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetLastCallRecords"));
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM)_T("GetPBXLoginLines"));
			LONG lResult = (LONG)SendMessage(hList,LB_FINDSTRING,(WPARAM)-1,(LPARAM)_T("Init"));
			if(lResult >= 0)
			{
				SendMessage(hList,LB_SETCURSEL,lResult,0);
			}// if(lResult >= 0)
			break;
		}// case WM_INITDIALOG
	case WM_COMMAND:
		{
			switch(LOWORD(_wParam))
			{
			case IDC_CMDLIST:
				{
					if(HIWORD(_wParam) == LBN_SELCHANGE)
					{
						CmdListSelChanged();
					}// if(HIWORD(_wParam) == LBN_SELCHANGE)
					break;
				}// case IDC_CMDLIST
			case IDC_RUN:
				{
					RunCmd();
					break;
				}// case IDC_RUN
			}// switch(LOWORD(_wParam))
			break;
		}// case WM_COMMAND
	}// switch(_wCommand)

	return 0;
}
//***************************************************************************************

// Command button page
INT_PTR WINAPI Page2DlgProc(HWND _hWnd,
	UINT _wCommand,
	WPARAM _wParam,
	LPARAM)
{
	switch(_wCommand)
	{
	case WM_INITDIALOG:
		{
			// Modify controls
			SendDlgItemMessage(_hWnd,IDC_CALLDEVICE,EM_LIMITTEXT,4,0);
			SetDlgItemInt(_hWnd,IDC_LICENSECOUNT,CTI_GetLicenseCount(),FALSE);
			CmdListSelChanged();
			
			break;
		}// case WM_INITDIALOG
	case WM_COMMAND:
		{
			switch(LOWORD(_wParam))
			{
			case IDC_BTNCONVERT:
				{
					TestFuncConvert();
					break;
				}// case IDC_BTNCONVERT
			case IDC_MAKECALL:
				{
					TestFuncMakeCall();
					break;
				}// case IDC_MAKECALL
			case IDC_ANSWER:
				{
					TestFuncAnswer();
					break;
				}// case IDC_ANSWER
			case IDC_REDIRECT:
				{
					TestFuncRedirect();
					break;
				}// case IDC_REDIRECT
			case IDC_SWAPHOLD:
				{
					TestFuncAlternate();
					break;
				}// case IDC_SWAPHOLD
			case IDC_TRANSFER:
				{
					TestFuncTransfer();
					break;
				}// case IDC_TRANSFER
			case IDC_CONFERENCE:
				{
					TestFuncConference();
					break;
				}// case IDC_CONFERENCE
			case IDC_PICKUP:
				{
					TestFuncPickup();
					break;
				}// case IDC_PICKUP
			case IDC_DROP:
				{
					TestFuncDrop();
					break;
				}// case IDC_DROP
			case IDC_DISPLAY:
				{
					TestFuncDisplay();
					break;
				}// case IDC_DISPLAY
			case IDC_SENDIDENT:
				{
					TestFuncSendIdentity();
					break;
				}// case IDC_SENDIDENT
			case IDC_SENDDATA:
				{
					TestFuncSendUserData();
					break;
				}// case IDC_SENDDATA
			}// switch(LOWORD(_wParam))
			break;
		}// case WM_COMMAND
	}// switch(_wCommand)

	return 0;
}
//***************************************************************************************

// New Cmd selected
VOID CmdListSelChanged(VOID)
{
	DisableAllParams();

	LONG lSelect = (LONG)SendDlgItemMessage(g_hWndPage1,IDC_CMDLIST,LB_GETCURSEL,0,0);
	if(lSelect < 0){return;}

	TCHAR szCmd[64] = _T("");
	SendDlgItemMessage(g_hWndPage1,IDC_CMDLIST,LB_GETTEXT,(WPARAM)lSelect,(LPARAM)szCmd);

	// Initial functions
	if(!_tcscmp(szCmd,_T("Init"))){}// Do nothing
	// Call functions
	else if(!_tcscmp(szCmd,_T("Alternate"))){InsertParams(_T("PTCHAR pszUser"));}
	else if(!_tcscmp(szCmd,_T("Answer"))){InsertParams(_T("PTCHAR pszUser"));}
	else if(!_tcscmp(szCmd,_T("Conference"))){InsertParams(_T("PTCHAR pszUser"));}
	else if(!_tcscmp(szCmd,_T("Drop"))){InsertParams(_T("PTCHAR pszUser"));}
	else if(!_tcscmp(szCmd,_T("Forward"))){InsertParams(_T("PTCHAR pszUser"),_T("PTCHAR pszNumber"));}
	else if(!_tcscmp(szCmd,_T("MakeCall"))){InsertParams(_T("PTCHAR pszUser"),_T("PTCHAR pszNumber"));}
	else if(!_tcscmp(szCmd,_T("Pickup"))){InsertParams(_T("PTCHAR pszUser"),_T("PTCHAR pszNumber"));}
	else if(!_tcscmp(szCmd,_T("Redirect"))){InsertParams(_T("PTCHAR pszUser"),_T("PTCHAR pszNumber"));}
	else if(!_tcscmp(szCmd,_T("SetPhoneDisplay"))){InsertParams(_T("PTCHAR pszNumber"),_T("PTCHAR pszText"));}
	else if(!_tcscmp(szCmd,_T("Transfer"))){InsertParams(_T("PTCHAR pszUser"));}
	// Message functions
	else if(!_tcscmp(szCmd,_T("SendAdminMessage"))){InsertParams(_T("PTCHAR pszUser"),_T("PTCHAR pszMessage"));}
	else if(!_tcscmp(szCmd,_T("SendIdentity"))){InsertParams(_T("LONG lCallId"),_T("PTCHAR pszUser"),_T("PTCHAR pszText"));}
	else if(!_tcscmp(szCmd,_T("SendUserData"))){InsertParams(_T("LONG lCommand"),_T("PTCHAR pszUser"),_T("PTCHAR pszText"));}
	// Transformation functions
	else if(!_tcscmp(szCmd,_T("ConvertToCanonical"))){InsertParams(_T("PTCHAR pszInput"),_T("*PTCHAR pszOutput"));}
	else if(!_tcscmp(szCmd,_T("GetDateTime"))){InsertParams(_T("LONG lTime"),_T("*PTCHAR pszTimeString (return value)"));}
	else if(!_tcscmp(szCmd,_T("GetFormatDateTime"))){InsertParams(_T("LONG lTime"),_T("PTCHAR pszFormat"),_T("*PTCHAR pszTimeString (return value)"));}
	// Information functions
	else if(!_tcscmp(szCmd,_T("GetLicenseCount"))){InsertParams(_T("*PLONG plVal (return value)"));}
	else if(!_tcscmp(szCmd,_T("GetNameFromExtension"))){InsertParams(_T("PTCHAR pszUser"),_T("BOOL bReserved"),_T("*PTCHAR pszName (return value)"));}
	else if(!_tcscmp(szCmd,_T("GetPBXFilters"))){InsertParams(_T("PTCHAR pszPBX"),_T("*PTCHAR pszOffice"),_T("*PTCHAR pszIntern"),_T("*PTCHAR pszInbound"),_T("*PTCHAR pszOutbound"));}
	else if(!_tcscmp(szCmd,_T("GetPBXMonitoredLines"))){InsertParams(_T("*PTCHAR pszLines"),_T("SIZE_T wSize"));}
	else if(!_tcscmp(szCmd,_T("GetTMServiceStatus"))){InsertParams(_T("*DWORD pdwVal (return value)"));}
	// Event trigger functions
	else if(!_tcscmp(szCmd,_T("GetAllUserCallStates"))){}// Do nothing
	else if(!_tcscmp(szCmd,_T("GetLastCallRecords"))){InsertParams(_T("PTCHAR pszUser"),_T("LONG lMaxCount"),_T("BOOL bDelete"));}
	else if(!_tcscmp(szCmd,_T("GetPBXLoginLines"))){}// Do nothing
}
//***************************************************************************************

// Disable all command params
VOID DisableAllParams(VOID)
{
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL1),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL2),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL3),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL4),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL5),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL6),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL7),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_LABEL8),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT1),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT2),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT3),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT4),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT5),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT6),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT7),SW_HIDE);
	ShowWindow(GetDlgItem(g_hWndPage1,IDC_EDIT8),SW_HIDE);
	SetDlgItemText(g_hWndPage1,IDC_EDIT1,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT2,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT3,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT4,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT5,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT6,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT7,_T(""));
	SetDlgItemText(g_hWndPage1,IDC_EDIT8,_T(""));
}
//***************************************************************************************

// Insert cmd params if present
VOID InsertParams(PTCHAR _p1,
						PTCHAR _p2,
						PTCHAR _p3,
						PTCHAR _p4,
						PTCHAR _p5,
						PTCHAR _p6,
						PTCHAR _p7,
						PTCHAR _p8)
{
	InsertSingleParam(_p1,IDC_LABEL1,IDC_EDIT1);
	InsertSingleParam(_p2,IDC_LABEL2,IDC_EDIT2);
	InsertSingleParam(_p3,IDC_LABEL3,IDC_EDIT3);
	InsertSingleParam(_p4,IDC_LABEL4,IDC_EDIT4);
	InsertSingleParam(_p5,IDC_LABEL5,IDC_EDIT5);
	InsertSingleParam(_p6,IDC_LABEL6,IDC_EDIT6);
	InsertSingleParam(_p7,IDC_LABEL7,IDC_EDIT7);
	InsertSingleParam(_p8,IDC_LABEL8,IDC_EDIT8);
}
//***************************************************************************************

// Insert a single param and the label
VOID InsertSingleParam(PTCHAR _pszLabel,DWORD _dwLabelId,DWORD _dwEditId)
{
	BOOL bReadOnly = FALSE;
	if(_pszLabel)
	{
		if(*_pszLabel == '*')
		{
			_pszLabel++;
			bReadOnly = TRUE;
		}// if(*_pszLabel == '*')
		SendDlgItemMessage(g_hWndPage1,_dwEditId,EM_SETREADONLY,bReadOnly,0);
		ShowWindow(GetDlgItem(g_hWndPage1,_dwLabelId),SW_SHOW);
		ShowWindow(GetDlgItem(g_hWndPage1,_dwEditId),SW_SHOW);
		SetDlgItemText(g_hWndPage1,_dwLabelId,_pszLabel);
	}// if(_pszLabel)
}
//***************************************************************************************

// Get Dlg param buffer
VOID GetCmdBuffer(VOID)
{
	GetDlgItemText(g_hWndPage1,IDC_EDIT1,g_szBuffer1,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT2,g_szBuffer2,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT3,g_szBuffer3,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT4,g_szBuffer4,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT5,g_szBuffer5,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT6,g_szBuffer6,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT7,g_szBuffer7,g_dwBufSize - 1);
	GetDlgItemText(g_hWndPage1,IDC_EDIT8,g_szBuffer8,g_dwBufSize - 1);
}
//***************************************************************************************

// Start the selected cmd
VOID RunCmd(VOID)
{
	LONG lSelect = (LONG)SendDlgItemMessage(g_hWndPage1,IDC_CMDLIST,LB_GETCURSEL,0,0);
	if(lSelect < 0){return;}

	TCHAR szCmd[64] = _T("");
	SendDlgItemMessage(g_hWndPage1,IDC_CMDLIST,LB_GETTEXT,(WPARAM)lSelect,(LPARAM)szCmd);

	GetCmdBuffer();

	if(!_tcscmp(szCmd,_T("Init")))
	{
		CTI_Init(DataCallback);
	}
	else if(!_tcscmp(szCmd,_T("Alternate")))
	{
		CTI_Alternate(g_szBuffer1);
	}
	else if(!_tcscmp(szCmd,_T("Answer")))
	{
		CTI_Answer(g_szBuffer1);
	}
	else if(!_tcscmp(szCmd,_T("Conference")))
	{
		CTI_Conference(g_szBuffer1);
	}
	else if(!_tcscmp(szCmd,_T("Drop")))
	{
		CTI_Drop(g_szBuffer1);
	}
	else if(!_tcscmp(szCmd,_T("Forward")))
	{
		CTI_Forward(g_szBuffer1,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("MakeCall")))
	{
		CTI_MakeCall(g_szBuffer1,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("Pickup")))
	{
		CTI_Pickup(g_szBuffer1,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("Redirect")))
	{
		CTI_Redirect(g_szBuffer1,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("SetPhoneDisplay")))
	{
		CTI_SetPhoneDisplay(g_szBuffer1,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("Transfer")))
	{
		CTI_Transfer(g_szBuffer1);
	}
	else if(!_tcscmp(szCmd,_T("SendAdminMessage")))
	{
		CTI_SendAdminMessage(g_szBuffer1,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("SendIdentity")))
	{
		LONG lCallID = _ttol(g_szBuffer1);
		CTI_SendIdentity(lCallID,g_szBuffer2,g_szBuffer3);
	}
	else if(!_tcscmp(szCmd,_T("SendIdentity")))
	{
		LONG lCommand = _ttol(g_szBuffer1);
		CTI_SendUserData(lCommand,g_szBuffer2,g_szBuffer3);
	}
	else if(!_tcscmp(szCmd,_T("ConvertToCanonical")))
	{
		CTI_ConvertToCanonical(g_szBuffer1,g_szBuffer2);
		SetDlgItemText(g_hWndPage1,IDC_EDIT2,g_szBuffer2);
	}
	else if(!_tcscmp(szCmd,_T("GetDateTime")))
	{
		__time32_t wTime = (__time32_t)_ttol(g_szBuffer1);
		PTCHAR pszTime = CTI_GetDateTime(wTime);
		SetDlgItemText(g_hWndPage1,IDC_EDIT2,pszTime);
	}
	else if(!_tcscmp(szCmd,_T("GetFormatDateTime")))
	{
		__time32_t wTime = (__time32_t)_ttol(g_szBuffer1);
		PTCHAR pszTime = CTI_GetFormatDateTime(wTime,g_szBuffer2);
		SetDlgItemText(g_hWndPage1,IDC_EDIT3,pszTime);
	}
	else if(!_tcscmp(szCmd,_T("GetLicenseCount")))
	{
		LONG lCount = CTI_GetLicenseCount();
		SetDlgItemInt(g_hWndPage1,IDC_EDIT1,lCount,TRUE);
	}
	else if(!_tcscmp(szCmd,_T("GetNameFromExtension")))
	{
		BOOL bReserved = (BOOL)_ttol(g_szBuffer2);
		CTI_GetNameFromExtension(g_szBuffer1,bReserved);
	}
	else if(!_tcscmp(szCmd,_T("GetPBXFilters")))
	{
		CTI_GetPBXFilters(g_szBuffer1,g_szBuffer2,g_szBuffer3,g_szBuffer4,g_szBuffer5);
		SetDlgItemText(g_hWndPage1,IDC_EDIT2,g_szBuffer2);
		SetDlgItemText(g_hWndPage1,IDC_EDIT3,g_szBuffer3);
		SetDlgItemText(g_hWndPage1,IDC_EDIT4,g_szBuffer4);
		SetDlgItemText(g_hWndPage1,IDC_EDIT5,g_szBuffer5);
	}
	else if(!_tcscmp(szCmd,_T("GetPBXLoginLines")))
	{
		CTI_GetPBXLoginLines();
	}
	else if(!_tcscmp(szCmd,_T("GetPBXMonitoredLines")))
	{
		size_t wSize = (size_t)_ttol(g_szBuffer2);
		if(!wSize){wSize = g_dwBufSize - 1;}
		if(wSize >= g_dwBufSize){wSize = g_dwBufSize - 1;}
		CTI_GetPBXMonitoredLines(g_szBuffer1,wSize);
		SetDlgItemText(g_hWndPage1,IDC_EDIT1,g_szBuffer1);
	}
	else if(!_tcscmp(szCmd,_T("GetTMServiceStatus")))
	{
		DWORD dwStatus = CTI_GetTMServiceStatus();
		SetDlgItemInt(g_hWndPage1,IDC_EDIT1,dwStatus,TRUE);
	}
	else if(!_tcscmp(szCmd,_T("GetAllUserCallStates")))
	{
		CTI_GetAllUserCallStates();
	}
	else if(!_tcscmp(szCmd,_T("GetLastCallRecords")))
	{
		LONG lMaxCount = (LONG)_ttol(g_szBuffer2);
		BOOL bDelete = (BOOL)_ttol(g_szBuffer3);
		CTI_GetLastCallRecords(g_szBuffer1,lMaxCount,bDelete);
	}// if(!_tcscmp(szCmd,...
}
//***************************************************************************************

// Callback Function
VOID WINAPI DataCallback(DWORD _dwType,LPVOID _lpVoid)
{
	switch(_dwType)
	{
	case CTI_CALLNUMBER:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_CALLNUMBER"));
			InsertListEvent(_T("  Internal: %s"),lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Call: 0x%08X"),lpMsg->m_lParam);
			InsertListEvent(_T("  Number: %s"),lpMsg->m_szMessage);
			break;
		}// case CTI_CALLNUMBER
	case CTI_CALLSTATE:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_CALLSTATE"));
			InsertListEvent(_T("  Internal: %s"),lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Call: 0x%08X"),lpMsg->m_lParam);
			InsertListEvent(_T("  State: 0x%08X"),lpMsg->m_wParam);
			break;
		}// case CTI_CALLSTATE
	case CTI_IDENTITY:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_IDENTITY"));
			InsertListEvent(_T("  Internal: %s"),lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Call: 0x%08X"), lpMsg->m_lParam);
			InsertListEvent(_T("  Number: %s"),lpMsg->m_szMessage);
			break;
		}// case CTI_IDENTITY
	case CTI_PROTOCOLDATA:
		{
			LP_CTI_PHONE_DATA lpData = (LP_CTI_PHONE_DATA)_lpVoid;
			InsertListEvent(_T("CTI_PROTOCOLDATA"));
			InsertListEvent(_T("  Internal: %s"),lpData->m_unActor.szNumber);
			InsertListEvent(_T("  Partner: %s"),lpData->m_szNumber);
			InsertListEvent(_T("  Address: %s"),lpData->m_szMessage);
			InsertListEvent(_T("  Connected: %d"),(lpData->m_dwFlags & 2) ? TRUE : FALSE);
			InsertListEvent(_T("  Inbound: %d"),(lpData->m_dwFlags & 4) ? TRUE : FALSE);
			InsertListEvent(_T("  StartTime: %s"),CTI_GetFormatDateTime((__time32_t)lpData->m_dwStart,
				_T("%H:%M:%S")));
			InsertListEvent(_T("  EndTime: %s"),CTI_GetFormatDateTime((__time32_t)lpData->m_dwEnd,
				_T("%H:%M:%S")));
			break;
		}// case CTI_PROTOCOLDATA
	case CTI_USERTODATABASE:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_USERTODATABASE"));
			InsertListEvent(_T("  Internal: %s"),lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Command: %d"),lpMsg->m_lParam);
			InsertListEvent(_T("  Message: %s"),lpMsg->m_szMessage);
			break;
		}// case CTI_USERTODATABASE
	case CTI_NEWCALL:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_NEWCALL"));
			InsertListEvent(_T("  Internal: %s"),lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Call: 0x%08X"),lpMsg->m_lParam);
			InsertListEvent(_T("  Time: %s"),CTI_GetDateTime((__time32_t)lpMsg->m_wParam));
			InsertListEvent(_T("  Inbound: 0x%08X"),lpMsg->m_unOther.wNumber);
			InsertListEvent(_T("  Number: %s"),lpMsg->m_szMessage);
			break;
		}// case CTI_NEWCALL
	case CTI_FORWARDINGSTATE:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_FORWARDINGSTATE"));
			InsertListEvent(_T("  Internal: %s"), lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Set: %d"), lpMsg->m_wParam);
			InsertListEvent(_T("  Target: %s"), lpMsg->m_szMessage);
			break;
		}// case CTI_FORWARDINGSTATE
	case CTI_LOGINDATA:
		{
			LP_CTI_COMMAND_MSG lpMsg = (LP_CTI_COMMAND_MSG)_lpVoid;
			InsertListEvent(_T("CTI_LOGINDATA"));
			InsertListEvent(_T("  Internal: %s"),lpMsg->m_unNumber.szNumber);
			InsertListEvent(_T("  Name: %s"),lpMsg->m_szMessage);
			InsertListEvent(_T("  Login: %d"),(lpMsg->m_wParam) ? 1 : 0);
			break;
		}// case CTI_LOGINDATA
	}// switch(_dwType)
}
//***************************************************************************************

// Insert new event into list
VOID InsertListEvent(PTCHAR _pszText,...)
{
   // Build string
   static TCHAR szBuffer[2048] = _T("");
   va_list ap;
   va_start(ap,_pszText);
	StringCchVPrintf(szBuffer,2048,_pszText,ap);
	va_end(ap);

	// Insert into list
	int nPos = (int)SendMessage(g_hEventList,LB_ADDSTRING,0,(LPARAM)szBuffer);
	SendMessage(g_hEventList,LB_SETCURSEL,nPos,0);
}
//***************************************************************************************

VOID TestFuncConvert(VOID)
{
	TCHAR szInput[64] = _T("");
	TCHAR szOutput[64] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CONVERTINPUT,szInput,63);
	CTI_ConvertToCanonical(szInput,szOutput);
	SetDlgItemText(g_hWndPage2,IDC_CONVERTOUTPUT,szOutput);
}
//***************************************************************************************

VOID TestFuncMakeCall(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	TCHAR szDest[32] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	GetDlgItemText(g_hWndPage2,IDC_CALLDEST,szDest,31);
	if(!szDevice[0]){return;}
	if(!szDest[0]){return;}

	// Make Call with the selected Device
	CTI_MakeCall(szDevice,szDest);
}
//***************************************************************************************

VOID TestFuncAnswer(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	if(!szDevice[0]){return;}

	// Answer
	CTI_Answer(szDevice);
}
//***************************************************************************************

VOID TestFuncRedirect(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	TCHAR szDest[32] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	GetDlgItemText(g_hWndPage2,IDC_CALLDEST,szDest,31);
	if(!szDevice[0]){return;}
	if(!szDest[0]){return;}

	// Call deflection
	CTI_Redirect(szDevice,szDest);
}
//***************************************************************************************

VOID TestFuncAlternate(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	if(!szDevice[0]){return;}

	// SwapHold / Alternate
	CTI_Alternate(szDevice);
}
//***************************************************************************************

VOID TestFuncTransfer(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	if(!szDevice[0]){return;}

	// Make a transfer
	CTI_Transfer(szDevice);
}
//***************************************************************************************

VOID TestFuncConference(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	if(!szDevice[0]){return;}

	// Make a conference
	CTI_Conference(szDevice);
}
//***************************************************************************************

VOID TestFuncPickup(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	TCHAR szDest[32] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	GetDlgItemText(g_hWndPage2,IDC_CALLDEST,szDest,31);
	if(!szDevice[0]){return;}
	if(!szDest[0]){return;}

	// Pickup a call
	CTI_Pickup(szDevice,szDest);
}
//***************************************************************************************

VOID TestFuncDrop(VOID)
{
	// Get Call Data
	TCHAR szDevice[8] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_CALLDEVICE,szDevice,5);
	if(!szDevice[0]){return;}

	// Answer
	CTI_Drop(szDevice);
}
//***************************************************************************************

VOID TestFuncDisplay(VOID)
{
	// Get Display Data
	TCHAR szDevice[8] = _T("");
	TCHAR szText[32] = _T("");
	GetDlgItemText(g_hWndPage2,IDC_DISPLAYDEVICE,szDevice,5);
	GetDlgItemText(g_hWndPage2,IDC_DISPLAYTEXT,szText,31);
	if(!szDevice[0]){return;}
	if(!szText[0]){return;}

	// Make Call with the selected Device
	CTI_SetPhoneDisplay(szDevice,szText);
}
//***************************************************************************************

// Send identity information to the client
VOID TestFuncSendIdentity(VOID)
{
	// Get Identity Data
	TCHAR szDevice[8] = _T("");
	TCHAR szText[256] = _T("");
	LONG lCall = (DWORD)GetDlgItemInt(g_hDlg,IDC_IDENTCALL,NULL,FALSE);
	GetDlgItemText(g_hWndPage2,IDC_IDENTDEVICE,szDevice,5);
	GetDlgItemText(g_hWndPage2,IDC_IDENTINFO,szText,255);
	if(!szDevice[0]){return;}
	if(!szText[0]){return;}

	// Send identity info
	CTI_SendIdentity(lCall,szDevice,szText);
}
//***************************************************************************************

// Send user defiened data to the client
VOID TestFuncSendUserData(VOID)
{
	// Get User Data
	TCHAR szDevice[8] = _T("");
	TCHAR szText[256] = _T("");
	LONG lCommand = (DWORD)GetDlgItemInt(g_hDlg,IDC_USERCOMMAND,NULL,FALSE);
	GetDlgItemText(g_hWndPage2,IDC_USERDEVICE,szDevice,5);
	GetDlgItemText(g_hWndPage2,IDC_USERDATA,szText,255);
	if(!szDevice[0]){return;}
	if(!szText[0]){return;}

	// Send user data
	CTI_SendUserData(lCommand,szDevice,szText);
}
//***************************************************************************************
