﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ServerCommands
{
	public partial class Form1 : Form
	{
		int m_nSelPos = 0;
		int m_nSubPos = 0;
		ListViewItem.ListViewSubItem m_SelectedLSI;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			// Init controls
			CmdList.Items.Add("---------------------------");
			CmdList.Items.Add("InitCOM");
			CmdList.Items.Add("SendIdentity");
			CmdList.Items.Add("SendUserData");
			CmdList.Items.Add("ConvertToCanonical");
			CmdList.Items.Add("MakeCall");
			CmdList.Items.Add("GetPBXFiltersAndPrefixes");
			CmdList.Items.Add("GetPBXMonitoredLines");
			CmdList.Items.Add("GetFilterCalibrationState");
			CmdList.Items.Add("GetExternPrefix");
			CmdList.Items.Add("GetInternPrefix");
			CmdList.Items.Add("GetInboundFilter");
			CmdList.Items.Add("GetOutboundFilter");
			CmdList.Items.Add("SetCalibrationParams");
			CmdList.Items.Add("LicenseCount");
			CmdList.Items.Add("SetPhoneDisplay");
			CmdList.Items.Add("ResetCalibration");
			CmdList.Items.Add("Answer");
			CmdList.Items.Add("Drop");
			CmdList.Items.Add("GetFormatDateTime");
			CmdList.Items.Add("GetDateTime");
			CmdList.Items.Add("Alternate");
			CmdList.Items.Add("Transfer");
			CmdList.Items.Add("Conference");
			CmdList.Items.Add("Pickup");
			CmdList.Items.Add("UserNameFromNumber");
			CmdList.Items.Add("UserCount");
			CmdList.Items.Add("GetExtension");
			CmdList.Items.Add("TMServiceStatus");
			CmdList.Items.Add("Forward");
			CmdList.Items.Add("GetAllUserCallStates");
			CmdList.Items.Add("GetLastCallRecords");
			int nInit = CmdList.Items.IndexOf("InitCOM");
			CmdList.SetSelected(nInit, true);

			// Init Param List
			ParamList.Columns.Add("Param", 120);
			ParamList.Columns.Add("Type", 120);
			ParamList.Columns.Add("Value", 200);

			// Init Event List
			EventList.Columns.Add("Event name", 100);
			EventList.Columns.Add("Param", 100);
			EventList.Columns.Add("Type", 100);
			EventList.Columns.Add("Value", 200);
		}

		private void axFCTIDataCtrl1_OnCallNumber(object sender, AxFCTIDATALib._IDataCtrlEvents_OnCallNumberEvent e)
		{
			// Phone number will be sended
			InsertEventListItem("OnCallNumber", "User", "string", e.bstrUser);
			InsertEventListItem("", "CallID", "long", e.lCallId.ToString());
			InsertEventListItem("", "Number", "string", e.bstrNumber);
		}

		private void axFCTIDataCtrl1_OnCallState(object sender, AxFCTIDATALib._IDataCtrlEvents_OnCallStateEvent e)
		{
			// Call state changed
			InsertEventListItem("OnCallState", "User", "string", e.bstrUser);
			InsertEventListItem("", "State", "long", e.lState.ToString());
			InsertEventListItem("", "CallID", "long", e.lCallId.ToString());
		}

		private void axFCTIDataCtrl1_OnGetIdentity(object sender, AxFCTIDATALib._IDataCtrlEvents_OnGetIdentityEvent e)
		{
			// Get identity of caller
			InsertEventListItem("OnGetIdentity", "CallId", "long", e.lCallId.ToString());
			InsertEventListItem("", "User", "string", e.bstrUser);
			InsertEventListItem("", "Number", "string", e.bstrNumber);
		}

		private void axFCTIDataCtrl1_OnLoginData(object sender, AxFCTIDATALib._IDataCtrlEvents_OnLoginDataEvent e)
		{
			// User is logging in
			InsertEventListItem("OnLoginData", "User", "string", e.bstrUser);
			InsertEventListItem("", "Name", "string", e.bstrName);
			InsertEventListItem("", "Login", "bool", e.bLogin.ToString());
		}

		private void axFCTIDataCtrl1_OnNewCall(object sender, AxFCTIDATALib._IDataCtrlEvents_OnNewCallEvent e)
		{
			// New call
			InsertEventListItem("OnNewCall", "User", "string", e.bstrUser);
			InsertEventListItem("", "CallId", "long", e.lCallId.ToString());
			InsertEventListItem("", "Inbound", "bool", e.bInbound.ToString());
			InsertEventListItem("", "Start", "long", e.lStart.ToString());
			InsertEventListItem("", "Number", "string", e.bstrNumber);
		}

		private void axFCTIDataCtrl1_OnProtocolData(object sender, AxFCTIDATALib._IDataCtrlEvents_OnProtocolDataEvent e)
		{
			// Call protocol
			InsertEventListItem("OnProtocolData", "Start", "long", e.lStart.ToString());
			InsertEventListItem("", "End", "long", e.lEnd.ToString());
			InsertEventListItem("", "User", "string", e.bstrUser);
			InsertEventListItem("", "Number", "string", e.bstrNumber);
			InsertEventListItem("", "Success", "bool", e.bSuccess.ToString());
			InsertEventListItem("", "Inbound", "bool", e.bInbound.ToString());
			InsertEventListItem("", "Address", "string", e.bstrAddress);
		}

		private void axFCTIDataCtrl1_OnUserToDataBase(object sender, AxFCTIDATALib._IDataCtrlEvents_OnUserToDataBaseEvent e)
		{
			// User sends Infos
			InsertEventListItem("OnUserToDataBase", "Command", "long", e.lCommand.ToString());
			InsertEventListItem("", "User", "string", e.bstrUser);
			InsertEventListItem("", "Message", "string", e.bstrMessage);
		}

		private void InsertParamListItem(int nPos, bool bEditable, string sName, string sType, string sValue)
		{
			ParamList.Items.Add(sName);
			if (bEditable) { ParamList.Items[nPos].UseItemStyleForSubItems = false; }
			ParamList.Items[nPos].SubItems.Add(sType);
			ParamList.Items[nPos].SubItems.Add(sValue);
			if (bEditable) 
			{
				ParamList.Items[nPos].SubItems[2].BackColor = System.Drawing.Color.Beige;
			}// if (bEditable) 
		}

		private void InsertEventListItem(string EventName, string Param, string Type, string Value)
		{
			EventList.Items.Add(EventName);
			int nPos = EventList.Items.Count - 1;
			if (EventName != "") { EventList.Items[nPos].BackColor = System.Drawing.Color.Aquamarine; }
			EventList.Items[nPos].SubItems.Add(Param);
			EventList.Items[nPos].SubItems.Add(Type);
			EventList.Items[nPos].SubItems.Add(Value);
			EventList.Items[nPos].EnsureVisible();
		}

		private void HideInputText()
		{
			m_TxtEdit.Visible = false;
			if (m_SelectedLSI != null) { m_SelectedLSI.Text = m_TxtEdit.Text; }
			m_SelectedLSI = null;
			m_TxtEdit.Text = "";
		}

		private void CmdList_SelectedIndexChanged(object sender, EventArgs e)
		{
			// Change selection
			string sSelectedCmd;
			sSelectedCmd = CmdList.Text;
			ParamList.Items.Clear();
			
			// Fill in parameters
			if (sSelectedCmd == "SendIdentity")
			{
				InsertParamListItem(0, true, "lCallId", "LONG", "0");
				InsertParamListItem(1, true, "bstrUser", "BSTR", "");
				InsertParamListItem(2, true, "bstrText", "BSTR", "");
			}
			else if (sSelectedCmd == "ConvertToCanonical")
			{
				InsertParamListItem(0, true, "bstrInput", "BSTR", "0123456789");
				InsertParamListItem(1, false, "bstrOutput", "BSTR*", "");
			}
			else if (sSelectedCmd == "SendUserData")
			{
				InsertParamListItem(0, true, "lCommand", "LONG", "");
				InsertParamListItem(1, true, "bstrUser", "BSTR", "");
				InsertParamListItem(2, true, "bstrText", "BSTR", "");
			}
			else if (sSelectedCmd == "MakeCall")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "GetPBXFiltersAndPrefixes")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, false, "bstrOffice", "BSTR*", "");
				InsertParamListItem(2, false, "bstrIntern", "BSTR*", "");
				InsertParamListItem(3, false, "bstrInbound", "BSTR*", "");
				InsertParamListItem(4, false, "bstrOutbound", "BSTR*", "");
			}
			else if (sSelectedCmd == "GetPBXMonitoredLines")
			{
				InsertParamListItem(0, false, "bstrLines", "BSTR*", "");
			}
			else if (sSelectedCmd == "GetFilterCalibrationState")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, false, "pVal", "LONG*", "");
			}
			else if (sSelectedCmd == "GetExternPrefix")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, false, "bstrPrefix", "BSTR*", "");
			}
			else if (sSelectedCmd == "GetInternPrefix")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, false, "bstrPrefix", "BSTR*", "");
			}
			else if (sSelectedCmd == "GetInboundFilter")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, false, "bstrFilter", "BSTR*", "");
			}
			else if (sSelectedCmd == "GetOutboundFilter")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, false, "bstrFilter", "BSTR*", "");
			}
			else if (sSelectedCmd == "SetCalibrationParams")
			{
				InsertParamListItem(0, true, "bstrPBX", "BSTR", "");
				InsertParamListItem(1, true, "bstrPrefixOffice", "BSTR", "");
				InsertParamListItem(2, true, "bstrPrefixIntern", "BSTR", "");
				InsertParamListItem(3, true, "bstrFilterIntern", "BSTR", "");
				InsertParamListItem(4, true, "bstrFilterExtern", "BSTR", "");
				InsertParamListItem(5, true, "bstrTestInbound", "BSTR", "");
				InsertParamListItem(6, true, "bstrTestOutbound", "BSTR", "");
			}
			else if (sSelectedCmd == "LicenseCount")
			{
				InsertParamListItem(0, false, "pVal", "LONG*", "");
			}
			else if (sSelectedCmd == "SetPhoneDisplay")
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
				InsertParamListItem(1, true, "bstrText", "BSTR", "");
			}
			else if (sSelectedCmd == "ResetCalibration")
			{
				// No arguments
			}
			else if (sSelectedCmd == "Answer")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
			}
			else if (sSelectedCmd == "Drop")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
			}
			else if (sSelectedCmd == "GetFormatDateTime")
			{
				InsertParamListItem(0, true, "lTime", "LONG", "0");
				InsertParamListItem(1, true, "bstrFormat", "BSTR", "%Y/%m/%d (%A)");
				InsertParamListItem(2, false, "bstrTimeString", "BSTR*", "");
			}
			else if (sSelectedCmd == "GetDateTime")
			{
				InsertParamListItem(0, true, "lTime", "LONG", "0");
				InsertParamListItem(1, false, "bstrTimeString", "BSTR*", "");
			}
			else if (sSelectedCmd == "Redirect")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "Alternate")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
			}
			else if (sSelectedCmd == "Transfer")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
			}
			else if (sSelectedCmd == "Conference")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
			}
			else if (sSelectedCmd == "Pickup")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "UserNameFromNumber")
			{
				InsertParamListItem(0, true, "bstrNumber", "BSTR", "");
				InsertParamListItem(1, false, "bstrUser", "BSTR*", "");
			}
			else if (sSelectedCmd == "UserCount")
			{
				InsertParamListItem(0, false, "pVal", "LONG*", "");
			}
			else if (sSelectedCmd == "GetExtension")
			{
				InsertParamListItem(0, true, "lPos", "LONG", "0");
				InsertParamListItem(1, false, "bstrExtension", "BSTR*", "");
			}
			else if (sSelectedCmd == "TMServiceStatus")
			{
				InsertParamListItem(0, false, "pVal", "LONG*", "");
			}
			else if (sSelectedCmd == "Forward")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
				InsertParamListItem(1, true, "bstrNumber", "BSTR", "");
			}
			else if (sSelectedCmd == "GetLastCallRecords")
			{
				InsertParamListItem(0, true, "bstrUser", "BSTR", "");
				InsertParamListItem(1, true, "lMaxCount", "LONG", "5");
				InsertParamListItem(2, true, "bDelete", "VARIANT_BOOL", "false");
			}// if (sSelectedCmd == ...
		}

		private void Form1_SizeChanged(object sender, EventArgs e)
		{
			// Resize controls
			ResizeComponents();
		}

		private void BtnClose_Click(object sender, EventArgs e)
		{
			// Close Program
			Close();
		}

		private void BtnRun_Click(object sender, EventArgs e)
		{
			// Get command
			string sSelectedCmd;
			sSelectedCmd = CmdList.Text;

			// Start command
			if (sSelectedCmd == "InitCOM")
			{
				axFCTIDataCtrl1.InitCOM(); 
			}
			else if (sSelectedCmd == "SendIdentity")
			{
				// Send identity lookup data to the client.
				int nCallId = 0;
				try
				{
					nCallId = int.Parse(ParamList.Items[0].SubItems[2].Text);
				}
				catch (Exception)
				{
				}
				string sUser = ParamList.Items[1].SubItems[2].Text;
				string sText = ParamList.Items[2].SubItems[2].Text;
				axFCTIDataCtrl1.SendIdentity(nCallId, sUser, sText);
			}
			else if (sSelectedCmd == "SendUserData")
			{
				// Send custom defined data to the client
				int nCommand = 0;
				try
				{
					nCommand = int.Parse(ParamList.Items[0].SubItems[2].Text);
				}
				catch (Exception)
				{
				}
				string sUser = ParamList.Items[1].SubItems[2].Text;
				string sText = ParamList.Items[2].SubItems[2].Text;
				axFCTIDataCtrl1.SendUserData(nCommand, sUser, sText);
			}
			else if (sSelectedCmd == "ConvertToCanonical")
			{
				// convert a phone number into a canonical format number
				string sInput = ParamList.Items[0].SubItems[2].Text;
				string sOutput;
				axFCTIDataCtrl1.ConvertToCanonical(sInput, out sOutput);
				ParamList.Items[1].SubItems[2].Text = sOutput;
			}
			else if (sSelectedCmd == "MakeCall")
			{
				// starts a call
				string sUser = ParamList.Items[0].SubItems[2].Text;
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				axFCTIDataCtrl1.MakeCall(sUser, sNumber);
			}
			else if (sSelectedCmd == "GetPBXFiltersAndPrefixes")
			{
				// Returns prefixes and filter numbers
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				string sOffice;
				string sIntern;
				string sInbound;
				string sOutbound;
				axFCTIDataCtrl1.GetPBXFiltersAndPrefixes(sPBX, out sOffice, out sIntern, out sInbound, out sOutbound);
				ParamList.Items[1].SubItems[2].Text = sOffice;
				ParamList.Items[2].SubItems[2].Text = sIntern;
				ParamList.Items[3].SubItems[2].Text = sInbound;
				ParamList.Items[4].SubItems[2].Text = sOutbound;
			}
			else if (sSelectedCmd == "GetPBXMonitoredLines")
			{
				// Returns the monitored PBX lines
				string sLines;
				axFCTIDataCtrl1.GetPBXMonitoredLines(out sLines);
				ParamList.Items[0].SubItems[2].Text = sLines;
			}
			else if (sSelectedCmd == "GetFilterCalibrationState")
			{
				// Get the state of the filter auto calibration
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				int nVal = 0;
				axFCTIDataCtrl1.GetFilterCalibrationState(sPBX, out nVal);
				ParamList.Items[1].SubItems[2].Text = nVal.ToString();
			}
			else if (sSelectedCmd == "GetExternPrefix")
			{
				// Prefix for external calls
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				string sPrefix;
				axFCTIDataCtrl1.GetExternPrefix(sPBX, out sPrefix);
				ParamList.Items[1].SubItems[2].Text = sPrefix;
			}
			else if (sSelectedCmd == "GetInternPrefix")
			{
				// Prefix for internal calls
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				string sPrefix;
				axFCTIDataCtrl1.GetInternPrefix(sPBX, out sPrefix);
				ParamList.Items[1].SubItems[2].Text = sPrefix;
			}
			else if (sSelectedCmd == "GetInboundFilter")
			{
				// Filter Inbound
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				string sFilter;
				axFCTIDataCtrl1.GetInboundFilter(sPBX, out sFilter);
				ParamList.Items[1].SubItems[2].Text = sFilter;
			}
			else if (sSelectedCmd == "GetOutboundFilter")
			{
				// Filter Outbound
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				string sFilter;
				axFCTIDataCtrl1.GetOutboundFilter(sPBX, out sFilter);
				ParamList.Items[1].SubItems[2].Text = sFilter;
			}
			else if (sSelectedCmd == "SetCalibrationParams")
			{
				// Set the Prefixes, Filter and calibration numbers.
				string sPBX = ParamList.Items[0].SubItems[2].Text;
				string sPrefixOffice = ParamList.Items[1].SubItems[2].Text;
				string sPrefixIntern = ParamList.Items[2].SubItems[2].Text;
				string sFilterIntern = ParamList.Items[3].SubItems[2].Text;
				string sFilterExtern = ParamList.Items[4].SubItems[2].Text;
				string sInbound = ParamList.Items[5].SubItems[2].Text;
				string sTestOutbound = ParamList.Items[6].SubItems[2].Text;
				axFCTIDataCtrl1.SetCalibrationParams(sPBX, sPrefixOffice, sPrefixIntern,
					sFilterIntern, sFilterExtern, sInbound, sTestOutbound);
			}
			else if (sSelectedCmd == "LicenseCount")
			{
				// Number of TAPIMaster licenses
				long lRetVal = axFCTIDataCtrl1.LicenseCount;
				ParamList.Items[0].SubItems[2].Text = lRetVal.ToString();
			}
			else if (sSelectedCmd == "SetPhoneDisplay")
			{
				// Set phone display information
				string sNumber = ParamList.Items[0].SubItems[2].Text;
				string sText = ParamList.Items[1].SubItems[2].Text;
				axFCTIDataCtrl1.SetPhoneDisplay(sNumber, sText);
			}
			else if (sSelectedCmd == "ResetCalibration")
			{
				// Reset calibration data (numbers and flags)
				axFCTIDataCtrl1.ResetCalibration();
			}
			else if (sSelectedCmd == "Answer")
			{
				// Answer
				string sUser = ParamList.Items[0].SubItems[2].Text;
				axFCTIDataCtrl1.Answer(sUser);
			}
			else if (sSelectedCmd == "Drop")
			{
				// Drop a call
				string sUser = ParamList.Items[0].SubItems[2].Text;
				axFCTIDataCtrl1.Drop(sUser);
			}
			else if (sSelectedCmd == "GetFormatDateTime")
			{
				// Get the time in an user defined format
				try
				{
					int nTime = int.Parse(ParamList.Items[0].SubItems[2].Text);
					string sFormat = ParamList.Items[1].SubItems[2].Text;
					string sTimeString;
					axFCTIDataCtrl1.GetFormatDateTime(nTime, sFormat, out sTimeString);
					ParamList.Items[2].SubItems[2].Text = sTimeString;
				}
				catch (Exception)
				{
					ParamList.Items[2].SubItems[2].Text = "Input error";
				}
			}
			else if (sSelectedCmd == "GetDateTime")
			{
				// Get Date time in an TM defined format
				try
				{
					int nTime = int.Parse(ParamList.Items[0].SubItems[2].Text);
					string sTimeString;
					axFCTIDataCtrl1.GetDateTime(nTime, out sTimeString);
					ParamList.Items[1].SubItems[2].Text = sTimeString;
				}
				catch (Exception)
				{
					ParamList.Items[1].SubItems[2].Text = "Input error";
				}
			}
			else if (sSelectedCmd == "Redirect")
			{
				// deflect an unanswered incoming call to an other destination
				string sUser = ParamList.Items[0].SubItems[2].Text;
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				axFCTIDataCtrl1.Redirect(sUser, sNumber);
			}
			else if (sSelectedCmd == "Alternate")
			{
				// Change the active and inactive call
				string sUser = ParamList.Items[0].SubItems[2].Text;
				axFCTIDataCtrl1.Alternate(sUser);
			}
			else if (sSelectedCmd == "Transfer")
			{
				// Transfer an active call to an waiting call
				string sUser = ParamList.Items[0].SubItems[2].Text;
				axFCTIDataCtrl1.Transfer(sUser);
			}
			else if (sSelectedCmd == "Conference")
			{
				// Start conference with two existign calls
				string sUser = ParamList.Items[0].SubItems[2].Text;
				axFCTIDataCtrl1.Conference(sUser);
			}
			else if (sSelectedCmd == "Pickup")
			{
				// Pickups a call from an other phone
				string sUser = ParamList.Items[0].SubItems[2].Text;
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				axFCTIDataCtrl1.Pickup(sUser, sNumber);
			}
			else if (sSelectedCmd == "UserNameFromNumber")
			{
				// Get the last logged in user name for this extension
				string sNumber = ParamList.Items[0].SubItems[2].Text;
				string sUser;
				axFCTIDataCtrl1.UserNameFromNumber(sNumber, out sUser);
				ParamList.Items[1].SubItems[2].Text = sUser;
			}
			else if (sSelectedCmd == "UserCount")
			{
				// Return the number of TAPI lines
				long lRetVal = axFCTIDataCtrl1.UserCount;
				ParamList.Items[0].SubItems[2].Text = lRetVal.ToString();
			}
			else if (sSelectedCmd == "GetExtension")
			{
				// Get Extension from TAPI line index
				int nPos = 0;
					try
				{
					nPos = int.Parse(ParamList.Items[0].SubItems[2].Text);
					string sExtension;
					axFCTIDataCtrl1.GetExtension(nPos, out sExtension);
					ParamList.Items[1].SubItems[2].Text = sExtension;
				}
				catch (Exception)
				{
					ParamList.Items[1].SubItems[2].Text = "Input error";
				}
			}
			else if (sSelectedCmd == "TMServiceStatus")
			{
				// Get the state of the TAPIMaster service
				long lRetVal = axFCTIDataCtrl1.TMServiceStatus;
				ParamList.Items[0].SubItems[2].Text = lRetVal.ToString();
			}
			else if (sSelectedCmd == "Forward")
			{
				// Start call forwarding
				string sUser = ParamList.Items[0].SubItems[2].Text;
				string sNumber = ParamList.Items[1].SubItems[2].Text;
				axFCTIDataCtrl1.Forward(sUser, sNumber);
			}
			else if (sSelectedCmd == "GetAllUserCallStates")
			{
				// Get user call states
				axFCTIDataCtrl1.GetAllUserCallStates();
			}
			else if (sSelectedCmd == "GetLastCallRecords")
			{
				// Get last call detail records
				try
				{
					string sUser = ParamList.Items[0].SubItems[2].Text;
					int lMaxCount = int.Parse(ParamList.Items[1].SubItems[2].Text);
					bool bDelete = bool.Parse(ParamList.Items[2].SubItems[2].Text);
					axFCTIDataCtrl1.GetLastCallRecords(sUser, lMaxCount, bDelete);
				}
				catch (Exception)
				{
					ParamList.Items[1].SubItems[2].Text = "Input error";
					ParamList.Items[2].SubItems[2].Text = "Input error";
				}
			}// if (sSelectedCmd == ...
		}
		
		private void ResizeComponents()
		{
			// Command list
			CmdList.Left = 5;
			CmdList.Top = 5;
			CmdList.Width = 220;
			CmdList.Height = Form1.ActiveForm.Height - 45;
			// Command param list
			ParamList.Left = 230;
			ParamList.Top = 5;
			ParamList.Width = Form1.ActiveForm.Width - 250;
			ParamList.Height = 200;
			// Event list
			EventList.Left = 230;
			EventList.Top = 210;
			EventList.Width = Form1.ActiveForm.Width - 250;
			EventList.Height = Form1.ActiveForm.Height - 280;
			// Buttons
			BtnRun.Left = 230;
			BtnRun.Top = Form1.ActiveForm.Height - 65;
			BtnClear.Left = 310;
			BtnClear.Top = Form1.ActiveForm.Height - 65;
			BtnClose.Left = Form1.ActiveForm.Width - 95;
			BtnClose.Top = Form1.ActiveForm.Height - 65;
		}

		private void Form1_Activated(object sender, EventArgs e)
		{
			ResizeComponents();
		}

		private void ParamList_MouseUp(object sender, MouseEventArgs e)
		{
			// Get selection
			ListViewHitTestInfo Info = ParamList.HitTest(e.X, e.Y);
			m_SelectedLSI = Info.SubItem;
			if (m_SelectedLSI == null) { return; }
			m_nSelPos = ParamList.Items.IndexOf(Info.Item);
			if (m_nSelPos < 0) { return; }
			m_nSubPos = ParamList.Items[m_nSelPos].SubItems.IndexOf(Info.SubItem);
			if (m_nSubPos < 2) { return; }
			Color cTest = Info.SubItem.BackColor;
			if (cTest != System.Drawing.Color.Beige) { return; }

			int nBorder = 0;
			switch (ParamList.BorderStyle)
			{
				case BorderStyle.FixedSingle:
					{
						nBorder = 1;
						break;
					}
				case BorderStyle.Fixed3D:
					{
						nBorder = 2;
						break;
					}
			}// switch (ParamList.BorderStyle)

			// Size of new edit box
			int nCellWidth = m_SelectedLSI.Bounds.Width;
			int nCellHeight = m_SelectedLSI.Bounds.Height;
			int nCellLeft = nBorder + ParamList.Left + Info.SubItem.Bounds.Left;
			int nCellTop = ParamList.Top + Info.SubItem.Bounds.Top;

			m_TxtEdit.Location = new Point(nCellLeft, nCellTop);
			m_TxtEdit.Size = new Size(nCellWidth, nCellHeight);
			m_TxtEdit.Visible = true;
			m_TxtEdit.BringToFront();
			m_TxtEdit.Text = Info.SubItem.Text;
			m_TxtEdit.Select();
			m_TxtEdit.SelectAll();
		}

		private void m_TxtEdit_Leave(object sender, EventArgs e)
		{
			HideInputText();
		}

		private void m_TxtEdit_KeyUp(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return) { HideInputText(); }
		}

		private void BtnClear_Click(object sender, EventArgs e)
		{
			EventList.Items.Clear();
		}

	}
}
