using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ServerInterfaceCSharp
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      // Init CTI interface
      private void Form1_Load(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.InitCOM();
         label18.Text = Convert.ToString(axFCTIDataCtrl1.LicenseCount);
      }

      private void button1_Click(object sender, EventArgs e)
      {
         String szFormattedNumber = "";
         axFCTIDataCtrl1.ConvertToCanonical(textBox1.Text, out szFormattedNumber);
         textBox2.Text = szFormattedNumber;
      }

      // Make a call
      private void button2_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.MakeCall(textBox3.Text, textBox4.Text);
      }

      // Answer a call
      private void button3_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Answer(textBox3.Text);
      }

      // Drop a call
      private void button4_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Drop(textBox3.Text);
      }

      // Set display text of a phone device (if supported)
      private void button5_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.SetPhoneDisplay(textBox5.Text, textBox6.Text);
      }

      // Send identity data to the client
      private void button6_Click(object sender, EventArgs e)
      {
         Int32 nCallID = Convert.ToInt32(textBox8.Text);
         axFCTIDataCtrl1.SendIdentity(nCallID, textBox7.Text, textBox9.Text);
      }

      // Send user defined data to the client
      private void button7_Click(object sender, EventArgs e)
      {
         Int32 nCommand = Convert.ToInt32(textBox11.Text);
         axFCTIDataCtrl1.SendUserData(nCommand, textBox12.Text, textBox10.Text);
      }

      // Clear event list
      private void button8_Click(object sender, EventArgs e)
      {
         listBox1.Items.Clear();
      }

      // Close form
      private void button9_Click(object sender, EventArgs e)
      {
         Close();
      }

        // Delivers the partner Number
        private void axFCTIDataCtrl1_OnCallNumber(object sender, AxFCTIDATALib._IDataCtrlEvents_OnCallNumberEvent e)
        {
            String szCallID = Convert.ToString(e.lCallId);
            listBox1.Items.Add("CTI_CALLNUMBER");
            listBox1.Items.Add("   Internal: " + e.bstrUser);
            listBox1.Items.Add("   Call: " + szCallID);
            listBox1.Items.Add("   Number: " + e.bstrNumber);
        }

        // Delevers the call status
        private void axFCTIDataCtrl1_OnCallState(object sender, AxFCTIDATALib._IDataCtrlEvents_OnCallStateEvent e)
        {
            String szCallID = Convert.ToString(e.lCallId);
            String szState = Convert.ToString(e.lState);
            listBox1.Items.Add("CTI_CALLSTATE");
            listBox1.Items.Add("   Internal: " + e.bstrUser);
            listBox1.Items.Add("   Call: " + szCallID);
            listBox1.Items.Add("   State: " + szState);
        }

        // Delivers info for identity 
        private void axFCTIDataCtrl1_OnGetIdentity(object sender, AxFCTIDATALib._IDataCtrlEvents_OnGetIdentityEvent e)
        {
            String szCallID = Convert.ToString(e.lCallId);
            listBox1.Items.Add("CTI_GETIDENTITY");
            listBox1.Items.Add("   Internal: " + e.bstrUser);
            listBox1.Items.Add("   Call: " + szCallID);
            listBox1.Items.Add("   Number: " + e.bstrNumber);
        }

        // Delivers informationen about a new call
       private void axFCTIDataCtrl1_OnNewCall(object sender, AxFCTIDATALib._IDataCtrlEvents_OnNewCallEvent e)
        {
            String szCallID = Convert.ToString(e.lCallId);
            String szInbound = "No";
            if (e.bInbound == true) { szInbound = "Yes"; }
            String szStartTime = "";
            axFCTIDataCtrl1.GetDateTime(e.lStart, out szStartTime);
            listBox1.Items.Add("CTI_NEWCALL");
            listBox1.Items.Add("   Internal: " + e.bstrUser);
            listBox1.Items.Add("   Call: " + szCallID);
            listBox1.Items.Add("   Inbound: " + szInbound);
            listBox1.Items.Add("   Time: " + szStartTime);
            listBox1.Items.Add("   Partner: " + e.bstrNumber);
        }

        // Delivers protocol data
        private void axFCTIDataCtrl1_OnProtocolData(object sender, AxFCTIDATALib._IDataCtrlEvents_OnProtocolDataEvent e)
        {
            String szConnected = "No";
            if (e.bSuccess == true) { szConnected = "Yes"; }
            String szInbound = "No";
            if (e.bInbound == true) { szInbound = "Yes"; }
            String szStartTime = "";
            String szEndTime = "";
            axFCTIDataCtrl1.GetFormatDateTime(e.lStart, "%H:%M:%S", out szStartTime);
            axFCTIDataCtrl1.GetFormatDateTime(e.lEnd, "%H:%M:%S", out szEndTime);
            listBox1.Items.Add("CTI_PROTOCOLDATA");
            listBox1.Items.Add("   Internal: " + e.bstrUser);
            listBox1.Items.Add("   Partner: " + e.bstrNumber);
            listBox1.Items.Add("   Address: " + e.bstrAddress);
            listBox1.Items.Add("   Connected: " + szConnected);
            listBox1.Items.Add("   Inbound: " + szInbound);
            listBox1.Items.Add("   StartTime: " + szStartTime);
            listBox1.Items.Add("   EndTime: " + szEndTime);

        }

        // User informations are sent to th database interface
        private void axFCTIDataCtrl1_OnUserToDataBase(object sender, AxFCTIDATALib._IDataCtrlEvents_OnUserToDataBaseEvent e)
        {
            String szCommand = Convert.ToString(e.lCommand);
            listBox1.Items.Add("CTI_USERTODATABASE");
            listBox1.Items.Add("   Internal:" + e.bstrUser);
            listBox1.Items.Add("   Command:" + szCommand);
            listBox1.Items.Add("   Text:" + e.bstrMessage);
        }

        // Forwarding Information
        private void axFCTIDataCtrl1_OnForwardingState(object sender, AxFCTIDATALib._IDataCtrlEvents_OnForwardingStateEvent e)
        {
            listBox1.Items.Add("CTI_FORWARDINGSTATE");
            listBox1.Items.Add("   Internal:" + e.bstrUser);
            listBox1.Items.Add("   Set:" + e.bSet);
            listBox1.Items.Add("   Target:" + e.bstrTarget);
        }

        private void button10_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Redirect(textBox3.Text, textBox4.Text);
      }

      private void button11_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Toggle(textBox3.Text);
      }

      private void button12_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Transfer(textBox3.Text);
      }

      private void button13_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Conference(textBox3.Text);
      }

      private void button14_Click(object sender, EventArgs e)
      {
         axFCTIDataCtrl1.Pickup(textBox3.Text, textBox4.Text);
      }


     }
}