//***************************************************************************************
// CTI Programming interface server
// Copyright  2001 - 2020 Tino Kasubke
//***************************************************************************************
#ifndef __CTIDATA_H__
#define __CTIDATA_H__
//***************************************************************************************
// Callback function
typedef VOID (__stdcall* DataCallbackProc)(DWORD,LPVOID);
typedef VOID(__stdcall* DebugCallbackProc)(LONG, PTCHAR);
//***************************************************************************************
// Initial functions
VOID WINAPI CTI_Init(DataCallbackProc);

// Call functions
VOID WINAPI CTI_Alternate(PTCHAR);
VOID WINAPI CTI_Answer(PTCHAR);
VOID WINAPI CTI_Conference(PTCHAR);
VOID WINAPI CTI_Drop(PTCHAR);
VOID WINAPI CTI_Forward(PTCHAR,PTCHAR);
VOID WINAPI CTI_MakeCall(PTCHAR,PTCHAR);
VOID WINAPI CTI_Pickup(PTCHAR,PTCHAR);
VOID WINAPI CTI_Redirect(PTCHAR,PTCHAR);
VOID WINAPI CTI_SetPhoneDisplay(PTCHAR,PTCHAR);
VOID WINAPI CTI_Transfer(PTCHAR);

// Message functions
VOID WINAPI CTI_SendAdminMessage(PTCHAR,PTCHAR);
VOID WINAPI CTI_SendIdentity(LONG,PTCHAR,PTCHAR);
VOID WINAPI CTI_SendUserData(LONG,PTCHAR,PTCHAR);

// Transformation functions
VOID WINAPI CTI_ConvertToCanonical(PTCHAR,PTCHAR);
PTCHAR WINAPI CTI_GetDateTime(__time32_t);
PTCHAR WINAPI CTI_GetFormatDateTime(__time32_t,PTCHAR);

// Information functions
LONG WINAPI CTI_GetLicenseCount();
PTCHAR WINAPI CTI_GetNameFromExtension(PTCHAR,BOOL);
VOID WINAPI CTI_GetPBXFilters(PTCHAR,PTCHAR,PTCHAR,PTCHAR,PTCHAR);
VOID WINAPI CTI_GetPBXMonitoredLines(PTCHAR,size_t);
DWORD WINAPI CTI_GetTMServiceStatus();
PTCHAR WINAPI CTI_GetForwardingState(PTCHAR,PBOOL);

// Event trigger functions
VOID WINAPI CTI_GetAllUserCallStates();
VOID WINAPI CTI_GetLastCallRecords(PTCHAR,LONG,BOOL);
VOID WINAPI CTI_GetPBXLoginLines();
//***************************************************************************************
#endif
//***************************************************************************************
