//****************************************************************************************
#include "stdafx.h"
//****************************************************************************************
IMPLEMENT_DYNAMIC(CListDlg, CDialog)
//****************************************************************************************
// Construction
CListDlg::CListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListDlg::IDD, pParent)
{
}
//****************************************************************************************
// Incer caller data
VOID CListDlg::InsertCaller(PTCHAR pszNumber,PTCHAR pszName)
{
	// Fill data into caller list
	if(pszName && *pszName)
	{
		m_LastCaller.SetWindowText(pszName);
	}
	else
	{
		m_LastCaller.SetWindowText(pszNumber);
	}// if(pszName && *pszName)

	// Actual time
	CTime Now = CTime::GetCurrentTime();
	CString TimeText = Now.Format(_T("%d.%m.%Y %H:%M:%S"));
	int nPos = m_List.InsertItem(0,TimeText.GetBuffer(0));
	if(*pszNumber){m_List.SetItemText(nPos,1,pszNumber);}
	else{m_List.SetItemText(nPos,1,_T("Unknown"));}
	if(pszName && *pszName){m_List.SetItemText(nPos,2,pszName);}
}
//****************************************************************************************
// Read data
void CListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Control(pDX, IDC_LASTCALLER, m_LastCaller);
}
//****************************************************************************************
// Create dialog
BOOL CListDlg::OnInitDialog(VOID)
{
	CDialog::OnInitDialog();

	// Prepare phone book
	m_List.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	m_List.InsertColumn(0,_T("Time"),LVCFMT_LEFT,120);
	m_List.InsertColumn(1,_T("Number"),LVCFMT_LEFT,120);
	m_List.InsertColumn(2,_T("Caller"),LVCFMT_LEFT,160);
	m_LastCaller.MoveWindow(100,7,310,15);

	// Load data
	LoadFromFile();
	
	return TRUE;
}
//****************************************************************************************
// Evaluate various notifications
BOOL CListDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	// Only messages from list
	if(wParam == IDC_LIST)
	{
		LPNMHDR pNmHdr = (LPNMHDR)lParam;
		switch(pNmHdr->code)
		{
		// Call by double click
		case NM_DBLCLK:
			{
				int nPos = m_List.GetNextItem(-1,LVNI_ALL | LVNI_SELECTED);
				if(nPos >= 0)
				{
					CString szNumber = m_List.GetItemText(nPos,1);
					CTI_TMakeCall(szNumber.GetBuffer(0));
				}// if(nPos >= 0)
				break;
			}
		// Press button
		case LVN_KEYDOWN:
			{
				// Lschtaste
				LPNMKEY pNmKey = (LPNMKEY)lParam;
				if(LOWORD(pNmKey->nVKey) == VK_DELETE)
				{
					int nPos = m_List.GetNextItem(-1,LVNI_ALL | LVNI_SELECTED);
					if(nPos >= 0)
					{
						m_List.DeleteItem(nPos);
					}// if(nPos >= 0)
				}// if(LOWORD(pNmKey->nVKey) == VK_DELETE)
				break;
			}// case LVN_KEYDOWN
		}// switch(pNmHdr->code)
	}// if(wParam == IDC_BOOK)
	
	return CWnd::OnNotify(wParam,lParam,pResult);
}
//****************************************************************************************
// Load caller list from HD
VOID CListDlg::LoadFromFile(VOID)
{
	CFile ListFile;
	CString szLine;
	TCHAR szTime[32];
	TCHAR szName[64];
	TCHAR szNumber[64];
	int nPos;
	int nListPos = 0;
	if(ListFile.Open(
		_T("Anruf.txt"),
		CFile::modeRead 
		| CFile::shareDenyNone 
		| CFile::modeCreate
		| CFile::modeNoTruncate))
	{
		CArchive Reader(&ListFile,CArchive::load);
		while(Reader.ReadString(szLine))
		{
			*szNumber = 0;
			*szName = 0;
			_stscanf_s(szLine.GetBuffer(0),_T("%31[^;];%63[^;];%63s"),szTime,31,szNumber,63,szName,63);
			nPos = m_List.InsertItem(nListPos,szTime);
			m_List.SetItemText(nPos,1,szNumber);
			m_List.SetItemText(nPos,2,szName);
			nListPos++;
		}
		ListFile.Close();
	}// if(ListFile.Open...
}
//****************************************************************************************
// Save caller list
VOID CListDlg::SaveToFile(VOID)
{
	CFile ListFile;
	if(ListFile.Open(
		_T("Anruf.txt"),
		CFile::modeWrite 
		| CFile::shareDenyNone 
		| CFile::modeCreate))
	{
		int nCount = m_List.GetItemCount();
		CString szTime;
		CString szNumber;
		CString szName;
		CString szLine;
		for(int n = 0;n < nCount;n++)
		{
			szTime = m_List.GetItemText(n,0);
			szNumber = m_List.GetItemText(n,1);
			szName = m_List.GetItemText(n,2);
			szLine = szTime + ";" + szNumber + ";" + szName + "\n";
			ListFile.Write(szLine,szLine.GetLength());
		}// for(int n = 0;n < nCount;n++)
		ListFile.Close();
	}// if(ListFile.Open...
}
//****************************************************************************************
BEGIN_MESSAGE_MAP(CListDlg, CDialog)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
END_MESSAGE_MAP()
//****************************************************************************************
// Show caller list
void CListDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	// Change size
	if(bShow)
	{
		CRect Pos;
		GetWindowRect(&Pos);
		m_List.MoveWindow(0,30,(Pos.right - Pos.left)-9,LIST_SIZE - 9);
	}// if(bShow)
}
//****************************************************************************************
// Remove dialog
void CListDlg::OnDestroy()
{
	CDialog::OnDestroy();

	SaveToFile();
}
//****************************************************************************************
