//****************************************************************************************
#include "stdafx.h"
//****************************************************************************************
#ifdef _DEBUG
#define new DEBUG_NEW
#endif
//****************************************************************************************
// ConstruCtor
CSQLDemoDlg::CSQLDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSQLDemoDlg::IDD, pParent)
	, m_szPassword(_T(""))
	, m_dwBeginCount(0)
	, m_szQuestion(_T(""))
	, m_dwRequestNext(0)
	, m_dwNextCount(0)
	, m_dwRequestEnd(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bIsConnected = FALSE;
	m_bSQLLoginOK = FALSE;
}
//****************************************************************************************
// Read dialog data
void CSQLDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LOGIN, m_BnLogin);
	DDX_Control(pDX, IDC_PASSWORD, m_Password);
	DDX_Text(pDX, IDC_PASSWORD, m_szPassword);
	DDX_Control(pDX, IDC_SQLBEGIN, m_BnBegin);
	DDX_Control(pDX, IDC_BEGINCOUNT, m_BeginCount);
	DDX_Text(pDX, IDC_BEGINCOUNT, m_dwBeginCount);
	DDX_Control(pDX, IDC_QUESTION, m_Question);
	DDX_Text(pDX, IDC_QUESTION, m_szQuestion);
	DDX_Control(pDX, IDC_REQUESTNEXT, m_RequestNext);
	DDX_Text(pDX, IDC_REQUESTNEXT, m_dwRequestNext);
	DDX_Control(pDX, IDC_NEXT, m_BnNext);
	DDX_Control(pDX, IDC_NEXTCOUNT, m_NextCount);
	DDX_Text(pDX, IDC_NEXTCOUNT, m_dwNextCount);
	DDX_Control(pDX, IDC_END, m_BnEnd);
	DDX_Control(pDX, IDC_REQUESTEND, m_RequestEnd);
	DDX_Text(pDX, IDC_REQUESTEND, m_dwRequestEnd);
	DDX_Control(pDX, IDC_ANSWER, m_Answer);
}
//****************************************************************************************
BEGIN_MESSAGE_MAP(CSQLDemoDlg, CDialog)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_NETWORK, OnBnClickedNetwork)
	ON_BN_CLICKED(IDC_LOGIN, OnBnClickedLogin)
	ON_BN_CLICKED(IDC_SQLBEGIN, OnBnClickedSqlbegin)
	ON_BN_CLICKED(IDC_NEXT, OnBnClickedNext)
	ON_BN_CLICKED(IDC_END, OnBnClickedEnd)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()
//****************************************************************************************
// Create dialog
BOOL CSQLDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);
	
	// Modify controls
	m_Password.SetLimitText(31);
	m_BeginCount.SetLimitText(4);
	m_BeginCount.SetWindowText(_T("1"));
	m_Question.SetLimitText(255);
	m_Question.SetWindowText(_T("SELECT * FROM members"));
	m_RequestNext.SetLimitText(3);
	m_NextCount.SetLimitText(3);
	m_NextCount.SetWindowText(_T("1"));
	m_RequestEnd.SetLimitText(3);

	// Set window handle
	CTI_ESetMainWindow(m_hWnd);

	// Verbindungsoptionen
	CTI_OSetOptions(					
		CTICLIENT_AUTOCONNECT		// Keep connection up automatically
		| CTICLIENT_SHOWICON			// Display connection icon
		| CTICLIENT_CHECKCONNECTION// Check connection settings when starting
		| CTICLIENT_AUTOLOGIN,		// Automatic log-on
		0);			
	
	// Start network connection
	CTI_NStartClientHWND(m_hWnd);

	// Update controls
	ActivateItems();
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}
//****************************************************************************************
// Evaluate various notifications
LRESULT CSQLDemoDlg::DefWindowProc(UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch(nMsg)
	{
	// Network OK
	case WM_CTI_NETWORKOPEN:
		{
			m_bIsConnected = TRUE;
			ActivateItems();
			return TRUE;
		}// case WM_CTI_NETWORKOPEN
	// Network interrupted
	case WM_CTI_NETWORKCLOSE:
		{
			m_bIsConnected = FALSE;
			m_bSQLLoginOK = FALSE;
			ActivateItems();
			return TRUE;
		}// case WM_CTI_NETWORKCLOSE
	// Server messages
	case WM_CTI_NETWORK_DISPATCH:
		{
			TranslateServerMessage((LP_CTI_COMMAND_MSG)lParam);
			return TRUE;
		}// case WM_CTI_NETWORK_DISPATCH
	}// switch(pMsg->message)

	return CWnd::DefWindowProc(nMsg,wParam,lParam);
}
//****************************************************************************************
// Change network settings
void CSQLDemoDlg::OnBnClickedNetwork()
{
	// Display network dialog
	CTI_NNetworkConfigDialog();
}
//****************************************************************************************
// Log-on to database
void CSQLDemoDlg::OnBnClickedLogin()
{
	// Get Password
	UpdateData();

	// Log-on
	CTI_SQLLogin(m_szPassword.GetBuffer(0));
}
//****************************************************************************************
// Start query
void CSQLDemoDlg::OnBnClickedSqlbegin()
{
	// Get Parameter
	UpdateData();

	// Start query
	DWORD dwRequest = CTI_SQLBegin(m_szQuestion.GetBuffer(0),m_dwBeginCount);
	SetDlgItemInt(IDC_REQUESTNEXT,dwRequest,FALSE);
	SetDlgItemInt(IDC_REQUESTEND,dwRequest,FALSE);
}
//****************************************************************************************
// Continue query
void CSQLDemoDlg::OnBnClickedNext()
{
	// Get Parameter
	UpdateData();

	// Get next records
	CTI_SQLNext(m_dwRequestNext,m_dwNextCount);
}
//****************************************************************************************
// Terminate query manually
void CSQLDemoDlg::OnBnClickedEnd()
{
	// Get Parameter
	UpdateData();

	// Close query
	CTI_SQLEnd(m_dwRequestEnd);
}
//****************************************************************************************
// Activate or deactivate controls
VOID CSQLDemoDlg::ActivateItems(VOID)
{
	m_BnLogin.EnableWindow(m_bIsConnected && !m_bSQLLoginOK);
	m_Password.EnableWindow(m_bIsConnected && !m_bSQLLoginOK);
	m_BnBegin.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_BeginCount.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_Question.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_BnNext.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_RequestNext.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_NextCount.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_BnEnd.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_RequestEnd.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
	m_Answer.EnableWindow(m_bIsConnected && m_bSQLLoginOK);
}
//****************************************************************************************
// Evaluate server messages
VOID CSQLDemoDlg::TranslateServerMessage(LP_CTI_COMMAND_MSG lpComMsg)
{
	switch(lpComMsg->m_dwCommand)
	{
	// Log-on to database
	case SQL_LOGIN:
		{
			if(lpComMsg->m_wParam)
			{
				m_Answer.AddString(_T("SQL_LOGIN: Login successful"));
			}
			else
			{
				m_Answer.AddString(_T("SQL_LOGIN: Login failed"));
			}// if(_lpComMsg->m_wParam)
			m_bSQLLoginOK = (BOOL)lpComMsg->m_wParam;
			ActivateItems();
			break;
		}// case SQL_LOGIN
	// Data records delivered
	case SQL_DATA:
		{
			InsertSQLReturn(_T("SQL_DATA"),lpComMsg);
			break;
		}
	// Query terminated
	case SQL_END:
		{
			TCHAR szReturn[64] = _T("");
			StringCchPrintf(szReturn,64,_T("Beenden von Abfrage %d Resultat %d"),
				lpComMsg->m_wParam,lpComMsg->m_lParam);
			m_Answer.AddString(szReturn);
			break;
		}// case SQL_END
	}// switch(_lpComMsg->m_dwCommand)
}
//****************************************************************************************
// Fill in data into list
VOID CSQLDemoDlg::InsertSQLReturn(PTCHAR pszCommand,LP_CTI_COMMAND_MSG lpComMsg)
{
	// Write data header
	TCHAR szHeader[256] = _T("");
	StringCchPrintf(szHeader,256,_T("%s: Request: %d Count: %d"),
		pszCommand,LOWORD(lpComMsg->m_wParam),lpComMsg->m_lParam);
	m_Answer.AddString(szHeader);

	// Data output
	PTCHAR pszBuffer = (PTCHAR)calloc(_tcslen(lpComMsg->m_szMessage) + 200,TCHAR_SIZE);
	if(pszBuffer)
	{
		if(lpComMsg->m_lParam > 0)
		{
			PTCHAR pszSource = lpComMsg->m_szMessage;
			PTCHAR pszDest = pszBuffer;
			while(*pszSource)
			{
				switch(*pszSource)
				{
				case 0x0A:break;
				case '\t':
					{
						*pszDest = ' ';
						pszDest++;
						*pszDest = ' ';
						pszDest++;
						*pszDest = ' ';
						pszDest++;
						break;
					}
				case 0x0D:
					{
						*pszDest = 0;
						pszDest = pszBuffer;
						m_Answer.AddString(pszBuffer);
						break;
					}
				default:
					{
						*pszDest = *pszSource;
						pszDest++;
						break;
					}
				}// switch(*pszSource)
				pszSource++;
			}// while(*pszSource)
		}// if(lpComMsg->m_lParam > 0)
		free(pszBuffer);
	}// if(pszBuffer)
}
//****************************************************************************************

// Delete list
void CSQLDemoDlg::OnBnClickedButton1()
{
	m_Answer.ResetContent();
}
//****************************************************************************************
