//*************************************************************************************
// Sample program for CTI client interface. Please import ActiveX control in your IDE.
// Then you can see a yellow phone symbol on "ActiveX" page. This symbol can placed
// on Delphi forms.
//*************************************************************************************
unit Unit1;
//*************************************************************************************
interface
//*************************************************************************************
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, FCTICLNTLib_TLB, StdCtrls, ComCtrls, Grids;
//*************************************************************************************
type
  TForm1 = class(TForm)
    FCTIClntCtrl1: TFCTIClntCtrl;
    BnNetwork: TButton;
    BnAnswer: TButton;
    BnDrop: TButton;
    BnBook: TCheckBox;
    Pages: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    LastCaller: TLabel;
    TelBook: TStringGrid;
    CallerList: TStringGrid;
    procedure BnNetworkClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BnAnswerClick(Sender: TObject);
    procedure BnDropClick(Sender: TObject);
    procedure FCTIClntCtrl1CallNumber(Sender: TObject; lType,
      lCallID: Integer; const bstrNumber: WideString);
    procedure FCTIClntCtrl1CallState(Sender: TObject; lState,
      lCallID: Integer);
    procedure FCTIClntCtrl1ConnectionState(Sender: TObject;
      lState: Integer);
    procedure BnBookClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TelBookDblClick(Sender: TObject);
    procedure CallerListDblClick(Sender: TObject);
    procedure CallerListKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TelBookKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure ActivateItems();
    procedure ShowLists();
    procedure HideLists();
    function GetIdentity(Number: string):string;
  public
    { Public declarations }
  end;
//*************************************************************************************
var
  Form1: TForm1;
  bIsConnected: Boolean;
  bActiveCall: Boolean;
  bRingingCall: Boolean;
//*************************************************************************************
implementation
//*************************************************************************************
{$R *.dfm}
//*************************************************************************************
// Prepare controls.
procedure TForm1.ActivateItems();
begin
  // Schalter fr Annehmen von Gesprchen
  if (bIsConnected = true) and (bRingingCall = true) then
     BnAnswer.Enabled := true
  else BnAnswer.Enabled := false;
  // Schalter fr Auflegen von Gesprchen
  if (bIsConnected = true) and (bActiveCall = true) then
    BnDrop.Enabled := true
  else BnDrop.Enabled := false;
end;
//*************************************************************************************
// Resize dialog.
procedure TForm1.ShowLists();
begin
  SetWindowPos(Handle,0,0,0,360,290,2);
  BnBook.Checked := true;
end;
//*************************************************************************************
// Hide lists
procedure TForm1.HideLists();
begin
  SetWindowPos(Handle,0,0,0,360,48,2);
  BnBook.Checked := false;
end;
//*************************************************************************************
// Caller identification.
function TForm1.GetIdentity(Number: string):string;
label LoopEnd;
var
  n: Integer;
begin
  GetIdentity := '';
  for n := 1 to 49 do
  begin
    if TelBook.Cells[1,n] = Number then
    begin
      GetIdentity := TelBook.Cells[0,n];
      goto LoopEnd;
    end;
  end;
  LoopEnd:
end;
//*************************************************************************************
// Create dialog
procedure TForm1.FormActivate(Sender: TObject);
begin
  // Initialize variables
  bIsConnected := false;
  bActiveCall := false;

  // Prepare lists
  HideLists();
  TelBook.ColWidths[0] := 160;
  TelBook.ColWidths[1] := 140;
  CallerList.ColWidths[0] := 110;
  CallerList.ColWidths[1] := 100;
  CallerList.ColWidths[2] := 90;

  // Load data
  try
    if FileExists('TelBook0.txt') then TelBook.Cols[0].LoadFromFile('TelBook0.txt');
    if FileExists('TelBook1.txt') then TelBook.Cols[1].LoadFromFile('TelBook1.txt');
    if FileExists('CallerList0.txt') then CallerList.Cols[0].LoadFromFile('CallerList0.txt');
    if FileExists('CallerList1.txt') then CallerList.Cols[1].LoadFromFile('CallerList1.txt');
    if FileExists('CallerList2.txt') then CallerList.Cols[2].LoadFromFile('CallerList2.txt');
  finally
  end;

  // Headline
  TelBook.Cells[0,0] := 'Name';
  TelBook.Cells[1,0] := 'Number';
  CallerList.Cells[0,0] := 'Time';
  CallerList.Cells[1,0] := 'NUmber';
  CallerList.Cells[2,0] := 'Name';

  // Check boxes as buttons
  SetWindowLong(BnBook.Handle,GWL_STYLE,$50011003);
 
  // Program settings
  FCTIClntCtrl1.ESetMainWindow(Form1.WindowHandle);
  FCTIClntCtrl1.OAutoConnect := true;   // Keep connection up automatically
  FCTIClntCtrl1.OShowIcon := true;      // Display connection icon
  FCTIClntCtrl1.OCheckConnetion := true;// Check connection settings when starting
  FCTIClntCtrl1.OAutoLogin := true;     // Automatic log-on
  FCTIClntCtrl1.OPhoneIcon := true;     // Call symbol

  // Start network connection
  FCTIClntCtrl1.NStartClient();
  ActivateItems();
end;
//*************************************************************************************
// Display network connection dialog
procedure TForm1.BnNetworkClick(Sender: TObject);
begin
  FCTIClntCtrl1.NNetworkConfigDialog();
end;
//*************************************************************************************
// Answer call
procedure TForm1.BnAnswerClick(Sender: TObject);
begin
  FCTIClntCtrl1.TCallAnswer(0);
end;
//*************************************************************************************
// Hang up call
procedure TForm1.BnDropClick(Sender: TObject);
begin
  FCTIClntCtrl1.TCallDrop(0);
end;
//*************************************************************************************
// A number is signalized. The caller list pulls down. If the caller can found in the 
// caller list, his name will be showed.
procedure TForm1.FCTIClntCtrl1CallNumber(Sender: TObject; lType,
  lCallID: Integer; const bstrNumber: WideString);
label LoopEnd;
var
  Identity: string;
  n: Integer;
begin
  // Only if not busy
  if lType = 1 then
  begin
    // Pull down list
    ShowLists();
    Pages.ActivePageIndex := 1;

    // Insert caller name
    Identity := GetIdentity(bstrNumber);
    if Identity = '' then
    begin
      LastCaller.Caption := bstrNumber;
    end
    else
    begin
      LastCaller.Caption := Identity;
    end;

    // Insert call data
    for n := 1 to 99 do
    begin
      Identity := CallerList.Cells[0,n];
      if (CallerList.Cells[0,n] = '') or (CallerList.Cells[0,n] = ' ') then
      begin
        CallerList.Cells[0,n] := DateTimeToStr(Now);
        CallerList.Cells[1,n] := bstrNumber;
        CallerList.Cells[2,n] := Identity;
        goto LoopEnd;
      end;
    end;
    LoopEnd:
  end;
end;
//*************************************************************************************
// Call state has changed. Change the state of buttons.
procedure TForm1.FCTIClntCtrl1CallState(Sender: TObject; lState,
  lCallID: Integer);
begin
  // State of active call
  case lstate of
    $0000:bActiveCall := false;
    $0001:bActiveCall := false;
    $4000:bActiveCall := false;
  else
    bActiveCall := true;
  end;
  // Other incoming calls present?
  case lstate of
    $0002:bRingingCall := true;
    $0004:bRingingCall := true;
  else
    bRingingCall := false;
  end;

  // Refresh buttons
  ActivateItems();
end;
//*************************************************************************************
// Signalize network state.
procedure TForm1.FCTIClntCtrl1ConnectionState(Sender: TObject;
  lState: Integer);
begin
  case lstate of
    3:bIsConnected := true;
  else
    bIsConnected := false;
  end;
  ActivateItems();
end;
//*************************************************************************************
// Pull down lists
procedure TForm1.BnBookClick(Sender: TObject);
begin
  if BnBook.Checked then
  begin
    Pages.ActivePageIndex := 0;
    ShowLists();
  end
  else
  begin
    HideLists();
  end;
end;
//*************************************************************************************
// Close program and save lists.
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Daten speichern
  TelBook.Cols[0].SaveToFile('TelBook0.txt');
  TelBook.Cols[1].SaveToFile('TelBook1.txt');
  CallerList.Cols[0].SaveToFile('CallerList0.txt');
  CallerList.Cols[1].SaveToFile('CallerList1.txt');
  CallerList.Cols[2].SaveToFile('CallerList2.txt');
end;
//*************************************************************************************
// Double click in phone book. The selected number will be called.
procedure TForm1.TelBookDblClick(Sender: TObject);
var
  nCurrentRow: LongInt;
  Number: string;
begin
  // Rufnummer wird gelesen und angerufen
  if bIsConnected = true then
  begin
    nCurrentRow := TelBook.Row;
    Number := TelBook.Cells[1,nCurrentRow];
    if Number > '' then FCTIClntCtrl1.TMakeCall(Number);
  end;
end;
//*************************************************************************************
// Call a entry of the caller list by double click.
procedure TForm1.CallerListDblClick(Sender: TObject);
var
  nCurrentRow: LongInt;
  Number: string;
begin
  // Rufnummer wird gelesen und angerufen
  if bIsConnected = true then
  begin
    nCurrentRow := CallerList.Row;
    Number := CallerList.Cells[1,nCurrentRow];
    if Number > '' then FCTIClntCtrl1.TMakeCall(Number);
  end;
end;
//*************************************************************************************
// Delete button is pressed.
procedure TForm1.CallerListKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  nCurrentRow: LongInt;
  n: Integer;
begin
  if Key = 46 then
  begin
    nCurrentRow := CallerList.Row;
    for n := nCurrentRow to 98 do
    begin
      CallerList.Cells[0,n] := CallerList.Cells[0,n + 1];
      CallerList.Cells[1,n] := CallerList.Cells[1,n + 1];
      CallerList.Cells[2,n] := CallerList.Cells[2,n + 1];
    end;
    CallerList.Cells[0,99] := '';
    CallerList.Cells[1,99] := '';
    CallerList.Cells[2,99] := '';
  end;
end;
//*************************************************************************************
procedure TForm1.TelBookKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  nCurrentRow: LongInt;
  n: Integer;
begin
  if Key = 46 then
  begin
    nCurrentRow := TelBook.Row;
    for n := nCurrentRow to 48 do
    begin
      TelBook.Cells[0,n] := TelBook.Cells[0,n + 1];
      TelBook.Cells[1,n] := TelBook.Cells[1,n + 1];
      TelBook.Cells[2,n] := TelBook.Cells[2,n + 1];
    end;
    TelBook.Cells[0,49] := '';
    TelBook.Cells[1,49] := '';
    TelBook.Cells[2,49] := '';
  end;
end;
//*************************************************************************************
end.
//*************************************************************************************


